<?php require_once('connectdb.php'); ?>
<?php

	// For debug
	$debugXmlParams = false;

    // ----- NO CACHE -----
	session_cache_limiter('nocache');

	header("Expires: Thu, 19 Nov 1981 08:52:00 GMT");
	/* For HTTP/1.1 conforming clients and the rest (MSIE 5) */
	header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
	/* For HTTP/1.0 conforming clients */
	header("Pragma: no-cache");

 	header("Content-Type: text/xml; charset=utf-8");
	// ----- Functions -----
	function formatAttributeValue($theValue) {
		$theValue = utf8_encode($theValue);
    	return $theValue;
    }

 	function formatAttributeNumberValue($theValue) {
 		if ($theValue == "") {
 			return "_NULL_";
 		}
     	return $theValue;
    }

	function formatTagValue($theValue) {
		if ($theValue == "") {
			return "_NULL_";
		}
	 	$theValue =	htmlspecialchars($theValue, ENT_COMPAT);
		$theValue = str_replace("'", "&apos;", $theValue);
		$theValue = utf8_encode($theValue);
    	return $theValue;
    }

	// ----- MySQL Connection -----
	mysql_select_db($database_db, $connect_db);

	// ----- Read params in XML -----
	$xmlParams = "";
	$domParams = new DOMDocument();

	if (isset($debug) && $debug == "1") {
		$domParams->load("debugParams.xml");
	} else {
		$xmlParams = file_get_contents("php://input");
		if ($xmlParams == "") {
			// die("*** WAIT A PARAMS XML FILE ***");
			$xmlParams = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?><params></params>";
		}
		$domParams->loadXML($xmlParams);

		if ($debugXmlParams) {
			$fp = fopen("debugParams.xml", "w");
			fwrite($fp, $domParams->saveXML());
			fclose($fp);
		}
	}



	// ----- Build where clause -----
	$nodeParams = $domParams->documentElement;

	$conditions = "";

	$priceMin = $nodeParams->getAttribute("priceMin");
	if ($priceMin != NULL && is_numeric ($priceMin) && intval($priceMin) != 0) {
		$conditions .= " AND (price >= " . $priceMin . ")";
	}

	$priceMax = $nodeParams->getAttribute("priceMax");
	if ($priceMax != NULL && is_numeric ($priceMax) && intval($priceMax) != 0) {
		$conditions .= " AND (price <= " . $priceMax . ")";
	}

	$bedrooms = $nodeParams->getAttribute("bedrooms");
	if ($bedrooms != NULL && is_numeric ($bedrooms)) {
		$conditions .= " AND (bedrooms >= " . $bedrooms . ")";
	}

	$bathrooms = $nodeParams->getAttribute("bathrooms");
	if ($bathrooms != NULL && is_numeric ($bathrooms)) {
		$conditions .= " AND (bathrooms >= " . $bathrooms . ")";
	}

	$footage = $nodeParams->getAttribute("footage");
	if ($footage != NULL && is_numeric ($footage)) {
		$conditions .= " AND (footage >= " . $footage . ")";
	}

	$status = $nodeParams->getAttribute("status");
	if ($status != NULL && $status != "") {
		$conditions .= " AND (status = '" . mysql_escape_string($status) . "')";
	}

	$hasPool = $nodeParams->getAttribute("hasPool");
	if ($hasPool != NULL && $hasPool == "1") {
		$conditions .= " AND (hasPool = 1)";
	}

	$hasLaundry = $nodeParams->getAttribute("hasLaundry");
	if ($hasLaundry != NULL && $hasLaundry == "1") {
		$conditions .= " AND (hasLaundry = 1)";
	}

	$hasFireplace = $nodeParams->getAttribute("hasFireplace");
	if ($hasFireplace != NULL && $hasFireplace == "1") {
		$conditions .= " AND (hasFireplace = 1)";
	}

	$hasWalkInClosets = $nodeParams->getAttribute("hasWalkInClosets");
	if ($hasWalkInClosets != NULL && $hasWalkInClosets == "1") {
		$conditions .= " AND (hasWalkInClosets = 1)";
	}

	// Special case for mls : all other conditions are removed
	// if mls = 'all' -> all the rows are returned
	$mls = $nodeParams->getAttribute("mls");
	if ($mls != NULL && $mls != "") {
		if (strtolower($mls) == "all" || $mls == "*") {
			$conditions = "";
		}
		else {
			$conditions = " AND (mls_id = '" . mysql_escape_string($mls) . "')";
		}
	}

	// Build where clause

	// ----- SQL command -----
	$query = "SELECT `mls_id`,`address`,`city`,`state`,`zipcode`,`status`,`price`,`bedrooms`,`bathrooms`,`stories`,`footage`,`yearBuilt`,`type`,`listedOn`,`hasPool`,`hasLaundry`,`hasFireplace`,`hasWalkInClosets`,`remarks` FROM listing";
	$query .= " WHERE mls_id IS NOT NULL " . $conditions . " ORDER BY price, listedOn";

	/*
	echo "<p> DEBUG ";
	echo "<br> conditions = " . $conditions ;
	echo "<br> query = " . $query ;
	echo "<br> --- </p>";
	die(" FIN ");
	*/

	$recordset = mysql_query($query, $connect_db) or die(mysql_error());

	// create document object
	$dom = new DOMDocument();
	$dom->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><listing></listing>");

	$rootNode = $dom->documentElement;

	while ($row_recordset = mysql_fetch_array($recordset)) {

		// create item node
		$record = new DOMElement("mls", "");
		$rootNode->appendChild($record);

		$record->setAttribute("id", $row_recordset[0]);
		$record->setAttribute("address", formatAttributeValue($row_recordset[1]));
		$record->setAttribute("city", formatAttributeValue($row_recordset[2]));
		$record->setAttribute("state", formatAttributeValue($row_recordset[3]));
		$record->setAttribute("zipcode", formatAttributeNumberValue($row_recordset[4]));
		$record->setAttribute("status", formatAttributeValue($row_recordset[5]));
		$record->setAttribute("price", formatAttributeNumberValue($row_recordset[6]));

		$record->setAttribute("bedrooms", formatAttributeNumberValue($row_recordset[7]));
		$record->setAttribute("bathrooms", formatAttributeNumberValue($row_recordset[8]));
		$record->setAttribute("stories", formatAttributeValue($row_recordset[9]));
		$record->setAttribute("footage", formatAttributeValue($row_recordset[10]));
		$record->setAttribute("yearBuilt", formatAttributeValue($row_recordset[11]));
		$record->setAttribute("type", formatAttributeValue($row_recordset[12]));
		$record->setAttribute("listedOn", $row_recordset[13]);

		$record->setAttribute("hasPool", formatAttributeValue($row_recordset[14]));
		$record->setAttribute("hasLaundry", formatAttributeValue($row_recordset[15]));
		$record->setAttribute("hasFireplace", formatAttributeValue($row_recordset[16]));
		$record->setAttribute("hasWalkInClosets", formatAttributeValue($row_recordset[17]));
		$record->setAttribute("remarks", formatAttributeValue($row_recordset[18]));
	}

	mysql_free_result($recordset);
	mysql_close();

	// print the XML
	print $dom->saveXML();
?>
