/*
 * RealEstate in Flash with PHP
 * by PhilFlash - http://philflash.inway.fr
 * 
 *
 * Initial version in ColdFusion. See:
 *  - The Real Estate Sample Application - Part 1: Building the Search Functionality with Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms.html
 *  - The Real Estate Sample Application - Part 2: Managing Property Listings Through Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms_pt2.html
 *
 * More information. See AsFusion Blog:
 *  - http://www.asfusion.com/blog/entry/coldfusion-flash-forms-macromedia-2
 *
 */

import mx.controls.Button;
import mx.controls.Alert;
import mx.controls.ProgressBar;
import mx.controls.TextArea;
import mx.controls.TextInput;
import mx.controls.Label;
import mx.controls.ComboBox;
import mx.controls.CheckBox;
import mx.controls.DateField;
import mx.controls.RadioButtonGroup;

import mx.controls.DataGrid;
import mx.controls.gridclasses.DataGridColumn;
import mx.data.components.DataSet;
import mx.data.components.XMLConnector;

import mx.data.components.datasetclasses.DataSetError;
import mx.data.to.ValueListIterator;
import mx.styles.CSSStyleDeclaration;

import mx.utils.Delegate;
import inway.IwEncart;

class form.MainForm extends mx.screens.Form {

	public var listing_ds:DataSet;
	public var listing_dg:DataGrid;

	private var grid_ie:IwEncart;
	private var edit_ie:IwEncart;
	
	private var backButton:Button;	
	private var debugButton:Button;
	private var filtreButton:Button;

	private var address_ti:TextInput;
	private var city_ti:TextInput;
	private var zip_ti:TextInput;
	
	private var price_ti:TextInput;
	private var bedrooms_ti:TextInput;
	private var bathrooms_ti:TextInput;
	private var yearbuilt_ti:TextInput;
	private var mls_ti:TextInput;
	private var stories_ti:TextInput;
	private var footage_ti:TextInput;
	private var listed_df:DateField;
	private var description_ta:TextArea;
	
	private var edit_status:RadioButtonGroup;
	
	private var hasPool_chb:CheckBox;
	private var hasLaundry_chb:CheckBox;
	private var hasFireplace_chb:CheckBox;
	private var hasWalkInClosets_chb:CheckBox;
	
	private var state_cb:ComboBox;
	private var type_cb:ComboBox;
	
	private var domaines:Array;
	private var nationalite:Array;
	private var preferenceDom:Array;
	
	private var initPerformed:Boolean = false;
	
	// Constructor
	public function MainForm() {}

	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);
	}

	// -----   ----- 	
	public function onLoad(obj:Object):Void {
		setVisible(true);
		//
		grid_ie.setStyle("styleName", "h1");
		edit_ie.setStyle("styleName", "h1");
		
		grid_ie.setHeaderGradient(0x277DC6,0x50ABF7);
		edit_ie.setHeaderGradient(0x277DC6,0x50ABF7);
		// --
		var labels:Array = ["address_lbl", "status_lbl", "amenities_lbl", "listing_lbl", "description_lbl"];
		var len:Number = labels.length;
 		for (var i:Number = 0; i < len; i++) {
 			var component = this[labels[i]];
			component.setStyle("styleName", "label");
		}
		// --	
		listing_dg.addEventListener("change", Delegate.create(this, doListingChangeAction));
		listing_ds.addEventListener("afterLoaded", Delegate.create(this, doListingAfterLoadedAction));

		//
		(rootForm).state_con.addEventListener("stateComplete", Delegate.create(this, doStateCompleteAction));
		// --
		listing_dg.editable = false;
		listing_dg.multipleSelection = false; 

		initStyleGrid(listing_dg);
		initColumnGrid(listing_dg); 
		// --
		var typeArray:Array = [];
		typeArray.push({data:"Condo/Townhouse"});
		typeArray.push({data:"Single Family Home"});
		typeArray.push({data:"Multi-Family Home"});
 		type_cb.dataProvider = typeArray;
 	}
 	
	// -----   -----   	
	public function onReveal(obj:Object):Void {
	}
	
	// -----   -----
	public function initStyleGrid(datagrid:DataGrid):Void {
		datagrid.setStyle("alternatingRowColors", Array(0xEAEFF4, 0xF8FAFB));

		datagrid.setStyle("hGridLines", true);
		datagrid.setStyle("hGridLineColor", 0xC1D1E0);
		datagrid.setStyle("vGridLines", true);
		datagrid.setStyle("vGridLineColor", 0xC1D1E0);

		datagrid.setStyle("borderStyle", "inset");
		// haut
		datagrid.setStyle("buttonColor", 0xFFFFFF);
		datagrid.setStyle("highlightColor", 0xFFFFFF);
		// cote
		datagrid.setStyle("borderCapColor", 0xFFFFFF);
		datagrid.setStyle("shadowCapColor", 0xFFFFFF);
		// bas
		datagrid.setStyle("shadowColor", 0x336699);
		datagrid.setStyle("borderColor", 0xFFFFFF);

		// If you want header
		// Header style
		var styleHeader:CSSStyleDeclaration= new mx.styles.CSSStyleDeclaration();
		styleHeader.styleName = "myHeader";
		styleHeader.fontFamily = "Verdana";
		styleHeader.fontSize = 10;
		styleHeader.fontWeight = "bold";
		//styleHeader.textAlign = "center";
		styleHeader.color = 0x336699;
		_global.styles["myHeader"] = styleHeader;

		datagrid.setStyle("headerStyle", styleHeader);
		datagrid.setHeaderHeight(20);
	}
	
	// -----  -----
	public function initColumnGrid(datagrid:DataGrid):Void {
		var newColumn:mx.controls.gridclasses.DataGridColumn;
		
		datagrid.removeAllColumns();

   		var cw = Math.floor((datagrid.width-18)/5); // 18 for vertical scrollbar
  
		newColumn = new mx.controls.gridclasses.DataGridColumn("type");
		newColumn.headerText = "Type";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("price");
		newColumn.headerText = "Price   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);

		newColumn = new mx.controls.gridclasses.DataGridColumn("bedrooms");
		newColumn.headerText = "Bedrooms   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);		
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("bathrooms");
		newColumn.headerText = "Bathrooms   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("footage");
		newColumn.headerText = "Footage   ";
		newColumn.width = cw;
		datagrid.addColumn(newColumn);
		//
		var col = datagrid.getColumnAt(1);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(2);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(3);
		col.setStyle("textAlign", "right");	
		
		col = datagrid.getColumnAt(4);
		col.setStyle("textAlign", "right");	
	}
	
	// -----   -----
	public function doListingAfterLoadedAction(evt:Object):Void {
		grid_ie.title = "Properties ("+listing_ds.length+")";
		grid_ie.setStyle("styleName", "h1");
		doLater(this, "selectFirstRow");
	}
	
	public function selectFirstRow() {
		listing_dg.vPosition = 0;
		listing_dg.selectedIndex = (listing_dg.length > 0 ? 0 : undefined);
		listing_dg.dispatchEvent({type:"change"});
	}
	
	// -----   -----
	public function doListingChangeAction(eventObj:Object):Void {
		var target = eventObj.target;
		var selectedItem = target.selectedItem;
		if (selectedItem == undefined) {
			address_ti.text = "";
			city_ti.text = "";
			zip_ti.text = "";
			price_ti.text = "";
			
			bedrooms_ti.text = "";
			bathrooms_ti.text = "";
			yearbuilt_ti.text = "";
			mls_ti.text = "";			
			stories_ti.text = "";
			footage_ti.text = "";
			description_ta.text = "";		
			
			//edit_status.selectedData = selectedItem.status;
			
			hasPool_chb.selected = false;
			hasLaundry_chb.selected = false;
			hasFireplace_chb.selected = false;
			hasWalkInClosets_chb.selected = false;
			
			
		} else {
			address_ti.text = selectedItem.address;
			city_ti.text = selectedItem.city;
			zip_ti.text = selectedItem.zipcode;
			selectOption(state_cb, selectedItem.state);
			
			price_ti.text = selectedItem.price;
			
			selectOption(type_cb, selectedItem.type);
			
			bedrooms_ti.text = selectedItem.bedrooms;
			bathrooms_ti.text = selectedItem.bathrooms;
			yearbuilt_ti.text = selectedItem.yearBuilt;
			mls_ti.text = selectedItem.id;			
			stories_ti.text = selectedItem.stories;
			footage_ti.text = selectedItem.footage;
			//
			description_ta.text = selectedItem.remarks;		
			
			edit_status.selectedData = selectedItem.status;
			
			hasPool_chb.selected = (selectedItem.hasPool == 1);
			hasLaundry_chb.selected = (selectedItem.hasLaundry == 1);
			hasFireplace_chb.selected = (selectedItem.hasFireplace == 1);
			hasWalkInClosets_chb.selected = (selectedItem.hasWalkInClosets == 1);
			
			var sd:String = selectedItem.listedOn;
			var date:Date = new Date( 0, 0, 0, 0, 0, 0 ); // exclude current time fix for bug#69845
			date.setYear(Number(sd.substr(6, 4)));
			date.setMonth(Number(sd.substr(3, 2))-1); // zero based
			date.setDate(Number(sd.substr(0, 2)));
					
			listed_df.selectedDate  = date;
		}
	}
			
	// -----   -----
	// States are loaded. A "stateComplete" event is received.
	public function doStateCompleteAction(eventObj:Object):Void {
		//trace(" doStateCommpleteAction ");
		state_cb.dataProvider = eventObj.data;
	}

	// -----   -----	
	public function selectOption(select:ComboBox, optionToSelect:String):Void {
		var dp = select.dataProvider;
		var len = dp.length;
		var indice:Number = 0;
		for (var i:Number = 0; i<len; i++) {
			if (dp[i].data == optionToSelect) {
				indice = i;
				break;
			}
		}
		select.selectedIndex = indice;
	}
}
    

