/*
 * RealEstate in Flash with PHP
 * by PhilFlash - http://philflash.inway.fr
 * 
 *
 * Initial version in ColdFusion. See:
 *  - The Real Estate Sample Application - Part 1: Building the Search Functionality with Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms.html
 *  - The Real Estate Sample Application - Part 2: Managing Property Listings Through Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms_pt2.html
 *
 * More information. See AsFusion Blog:
 *  - http://www.asfusion.com/blog/entry/coldfusion-flash-forms-macromedia-2
 *
 */

import mx.utils.Delegate;

import mx.controls.Alert;
import mx.controls.Button;
import mx.controls.Label;
import mx.controls.List;
import mx.controls.TextInput;
import mx.controls.TextArea;
import mx.controls.ComboBox;
import mx.controls.CheckBox;
import mx.controls.RadioButtonGroup;

import inway.IwEncart;
import form.ApplicationForm;

import mx.data.components.XMLConnector;
import mx.data.components.DataSet;
import mx.data.to.ValueListIterator;
import mx.controls.DataGrid;
import mx.controls.gridclasses.DataGridColumn;

class form.SearchForm extends mx.screens.Form {
	public var listing_con:XMLConnector;
	
	private var search_ie:IwEncart;
	private var searchButton:Button;
	
	private var priceMin_cb:ComboBox;
	private var priceMax_cb:ComboBox;
	
	private var bedrooms_cb:ComboBox;
	private var bathrooms_cb:ComboBox;	
	private var footage_cb:ComboBox;
	
	private var mls_ti:TextInput;

	private var status_rg:RadioButtonGroup;	
	
	private var hasPool_chb:CheckBox;
	private var hasLaundry_chb:CheckBox;
	private var hasFireplace_chb:CheckBox;
	private var hasWalkInClosets_chb:CheckBox;
	
	// Constructor
	public function SearchForm() {}
	
	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);
	}

	// -----   ----- 	
	public function onLoad(obj:Object):Void {
		setVisible(true);
		
		//
		search_ie.setStyle("styleName", "h1");
		search_ie.setHeaderGradient(0xAE0C0A,0x8C0A08);
		//
		var labels:Array = ["price_lbl", "bedroom_lbl", "bathroom_lbl", "footage_lbl", "mls_lbl", "status_lbl", "amenities_lbl"];
		var len:Number = labels.length;
 		for (var i:Number = 0; i < len; i++) {
 			var component = this[labels[i]];
			component.setStyle("styleName", "label");
		}
		// -- --
		var priceMinDP:Array = [];
		var priceMaxDP:Array = [];
		var i:Number;
		
		for (i = 75000; i <= 400000; i = i + 25000) {
			var sprice = currencyFormat(i, 0, "", ",", "",false,9);
			priceMinDP.push({data:i, label:sprice}); // format "9,999,999"
			priceMaxDP.push({data:i, label:sprice});
		}
		
		for (i = 450000; i <= 900000; i = i + 50000) {
			var sprice = currencyFormat(i, 0, "", ",", "",false,9);
			priceMinDP.push({data:i, label:sprice}); // format "9,999,999"
			priceMaxDP.push({data:i, label:sprice});
		}
		
		for (i = 1000000; i <= 3000000; i = i + 250000) {
			var sprice = currencyFormat(i, 0, "", ",", "",false,9);
			priceMinDP.push({data:i, label:sprice}); // format "9,999,999"
			priceMaxDP.push({data:i, label:sprice});
		}
		
		for (i = 3000000; i <= 9000000; i = i + 1000000) {
			var sprice = currencyFormat(i, 0, "", ",", "",false,9);
			priceMinDP.push({data:i, label:sprice}); // format "9,999,999"
			priceMaxDP.push({data:i, label:sprice});
		}
		
		priceMinDP.unshift({data:0, label:"No min."});
		priceMin_cb.dataProvider = priceMinDP;
		
		priceMaxDP.unshift({data:0, label:"No max."});
		priceMax_cb.dataProvider = priceMaxDP;
		
		// -- --
		var bedroomsDP:Array =  [	{data:0, label:"Any"}, 
						{data:1, label:"1 or more"}, 
						{data:2, label:"2 or more"}, 
						{data:3, label:"3 or more"}, 
						{data:4, label:"4 or more"}, 
						{data:5, label:"5 or more"}, 
						{data:6, label:"6 or more"} ];
		bedrooms_cb.dataProvider = bedroomsDP;

		var bathroomsDP:Array =  [	{data:1, label:"1 or more"}, 
						{data:1.5, label:"1.5 or more"}, 
						{data:2, label:"2 or more"}, 
						{data:2.5, label:"2.5 or more"}, 
						{data:3, label:"3 or more"}, 
						{data:3.5, label:"3.5 or more"}, 
						{data:4, label:"4 or more"} ];
		bathrooms_cb.dataProvider = bathroomsDP;
		
		var footageDP:Array =  [	{data:500, label:"500"}, 
						{data:750, label:"750"}, 
						{data:1000, label:"1000"}, 
						{data:1250, label:"1250"}, 
						{data:1500, label:"1500"}, 
						{data:2000, label:"2000"}, 
						{data:2250, label:"2250"}, 
						{data:2500, label:"2500"}, 
						{data:3000, label:"3000"},
						{data:3500, label:"3500"},
						{data:4000, label:"4000"}
						];
		footage_cb.dataProvider = footageDP;
		// ---
		listing_con.addEventListener("status", Delegate.create(this, doStatusListingAction));	
		listing_con.addEventListener("result", Delegate.create(this, doResultListingAction));
		// -- --
		searchButton.addEventListener("click", Delegate.create(this, doSearchAction));
	}

	// -----   ----- 	
	public function onReveal(obj:Object):Void {
	}
	
	// -----   ----- 
	public function doSearchAction():Void {
		var listingXML:XML = new XML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><params></params>");
		var rootNode = listingXML.firstChild;  
		
		// -- --
		var min = priceMin_cb.selectedItem.data
		rootNode.attributes.priceMin = min;
		
		var max = priceMax_cb.selectedItem.data;
		if (max < min) {
			max = 0;
			priceMax_cb.selectedIndex = 0;
		}
		rootNode.attributes.priceMax = max;		
		// -- --
		var mls = trimSpacer(mls_ti.text);
		rootNode.attributes.mls = mls;
		if (mls != "") {
			resetSearch();
		}
		
		if (bedrooms_cb.selectedItem != undefined) {
			rootNode.attributes.bedrooms = bedrooms_cb.selectedItem.data;	
		}

		if (bathrooms_cb.selectedItem != undefined) {
			rootNode.attributes.bathrooms = bathrooms_cb.selectedItem.data;	
		}
		
		if (footage_cb.selectedItem != undefined) {
			rootNode.attributes.footage = footage_cb.selectedItem.data;	
		}
		
		rootNode.attributes.status = status_rg.selectedData;
		rootNode.attributes.hasPool = (hasPool_chb.selected ? 1 : 0);		
		rootNode.attributes.hasLaundry = (hasLaundry_chb.selected ? 1 : 0);
		rootNode.attributes.hasFireplace = (hasFireplace_chb.selected ? 1 : 0);
		rootNode.attributes.hasWalkInClosets = (hasWalkInClosets_chb.selected ? 1 : 0);
		//trace(" params XML = "+listingXML);
		// send XML
		listing_con.params = listingXML;
		listing_con.trigger();
		// 
		enableProgress(true, "Search...");
	}
	
	// -----   ----- 
	public function resetSearch():Void {
		priceMax_cb.selectedIndex = 0;
		priceMin_cb.selectedIndex = 0;
		
		bedrooms_cb.selectedIndex = 0;
		bathrooms_cb.selectedIndex = 0;
		footage_cb.selectedIndex = 0;
		
		mls_ti.text = "";
		
		status_rg.selectedData = "active";
		
		hasPool_chb.selected = false;
		hasLaundry_chb.selected = false;
		hasFireplace_chb.selected = false;
		hasWalkInClosets_chb.selected = false;
	}
	
	
	// ----- Resultat sur XMLConnector -----
	public function doStatusListingAction(stat:Object):Void {
		// Erreur sur code ASP
		if (stat.code != "StatusChange") {
			var error = "Erreur de l'application : " + stat.target._name + "/" + stat.code + "/" + stat.data.faultcode + "/" + stat.data.faultstring;
			enableProgress(false);
			showError(error);
		}	
	}
	
	public function doResultListingAction():Void {
		// get result
		var resultXML:XML = listing_con.results;		
		var rootNode = resultXML.firstChild;
		var resultArray:Array = [];
			
		//trace("doResultListingAction = "+resultXML);
		// parse XML
		var aNode:XMLNode = rootNode.firstChild;
		while (aNode) {
			var obj = new Object();
			for (var attribute:String in aNode.attributes) {
				if (attribute == "id" || attribute == "address" || attribute == "city" || attribute == "status" || attribute == "type" || attribute == "remarks" || attribute == "state" || attribute == "stories") {
					// String
					obj[attribute] = aNode.attributes[attribute];	
				} else if (attribute == "listedOn") {
					// Date : format YYYY-MM-DD
					var sd:String = aNode.attributes[attribute];
					var date:Date = new Date( 0, 0, 0, 0, 0, 0 ); // exclude current time fix for bug#69845
					date.setYear(Number(sd.substr(0, 4)));
					date.setMonth(Number(sd.substr(5, 2))-1); // zero based
					date.setDate(Number(sd.substr(8, 2)));
					obj[attribute] = date.valueOf(); // doit tre le nombre de milliseconds				
				} else {
					// Number
					var value = aNode.attributes[attribute];
					if (value == "_NULL_") value = "0";
					obj[attribute] = Number(value);
				}
			}
			resultArray.push(obj);
			aNode = aNode.nextSibling;
		}
		var dataset:DataSet = (rootForm).main.listing_ds;
		dataset.filtered = false;
		dataset.items = resultArray;
		enableProgress(false);
	}		

	// -----  -----
	private function enableProgress(enabled:Boolean, label:String):Void {
		(rootForm).enableProgress(enabled, label);
		searchButton.enabled = !enabled;
	}
	
	private function showError(message:String):Void {
		var alertWindow:Alert = Alert.show(	message, 
										"Application Error                     ", 
										Alert.OK, this);
		alertWindow.startDragging = function() {};
		(rootForm).setLocationRelativeTo(alertWindow, null);	
	}
	// -----  -----	
	// See http://www.oreillynet.com/pub/a/javascript/excerpt/ActionScriptCkbk_chap1/
	// Or http://flash.terra.ee/flash-books/o'reilly%20-%20actionscript.cookbook.2003/
	//  for more information
	// Example : 
	// trace(currencyFormat(1.2));                    // Displays: $1.20
	// trace(currencyFormat(.3));                     // Displays: $0.30
	// trace(currencyFormat(1234567));                // Displays: $1,234,567.00
	// trace(currencyFormat(12.34, 2, "\u20AC"));     // Displays: E12.34 (euros)
	// trace(currencyFormat(12.34, 2, "\u00a3"));     // Displays: 12.34 (pounds)
	// trace(currencyFormat(12.34, 2, "\u00a5"));     // Displays: 12.34 (yen)
	// trace(currencyFormat(1.2, 2, "", ".", ","));   // Displays: 1,20
	// trace(currencyFormat(1234, 2, "", ".", ","));  // Displays: 1.234,00
	
	// format a number as currency, such as dollars.
	// num            : The number to format.
	// decimalPl      : The number of decimal places in the formatted number.
	// currencySymbol : The symbol, such as a dollar sign ($), to use.
	// thousandsDelim : The characters used to delimit thousands, millions, etc.
    // decimalDelim   : The characters used to delimit the fractional portion from the whole number.
	// truncate       : If true, truncate the number to the specified number of decimal places; otherwise, round the number.
	// spaceFill      : The number of spaces the entire formatted string should occupy.

	function currencyFormat(num:Number, decimalPl:Number, currencySymbol:String, thousandsDelim:String,
                      decimalDelim:String, truncate:Boolean, spaceFill:Number):String {
		// Default to two decimal places, a dollar sign ($), a comma for thousands, 
		// and a period for the decimal point. We implemented the defaults using 
		// the conditional operator. Compare with Recipe 5.5.
		decimalPl      = (decimalPl == undefined)      ? 2   : decimalPl;
		currencySymbol = (currencySymbol == undefined) ? "$" : currencySymbol;
		thousandsDelim = (thousandsDelim == undefined) ? "," : thousandsDelim;
		decimalDelim   = (decimalDelim == undefined)   ? "." : decimalDelim;
		if (decimalPl == 0) { decimalDelim = ""; } // *** PATCH PHILFLASH ***
		// Split the number into the whole and decimal (fractional) portions.
		var parts = String(num).split(".");
		// Truncate or round the decimal portion, as directed.
		if (truncate) {
		parts[1] = Number(parts[1]) * Math.pow(10, -(decimalPl - 1));
		parts[1] = String(Math.floor(parts[1]));
		} else {
		// Requires the roundDecPl(  ) method defined in Recipe 5.3
		parts[1] = roundDecPl(Number("." + parts[1]), decimalPl);
		parts[1] = String(parts[1]).split(".")[1];
		}
		// Ensure that the decimal portion has the number of digits indicated. 
		// Requires the zeroFill(  ) method defined in Recipe 5.4.
		parts[1] = zeroFill(parts[1], decimalPl, true);
		// If necessary, use the numberFormat(  ) method from Recipe 5.5 to 
		// format the number with the proper thousands delimiter and leading spaces.
		if (thousandsDelim != "" || spaceFill != undefined) {
		parts[0] = numberFormat(parts[0], thousandsDelim, "",
					spaceFill - decimalPl - currencySymbol.length);
		}
		// Add a currency symbol and use String.join(  ) to merge the whole (dollar)
		// and decimal (cents) portions using the designated decimal delimiter.
		return currencySymbol + parts.join(decimalDelim);
	}

	// format a number with leading or trailing zeros and invoke it whenever it is needed.
	// num      : The number you want to format.
	// places   : The number of total digits that should be filled in the resulting, formatted numeric string.
	// trailing : If true, then the zeros are appended to the string. Otherwise, the zeros are prepended.
	function zeroFill (num:Number, places:Number, trailing:Boolean):String {
		// Convert the number to a string.
		//var filledVal = String(num);
		var filledVal = String((num == undefined ? "" : num)); // *** PATCH PHILFLASH ***
		// Get the length of the string.
		var len = filledVal.length;
		// Use a for statement to add the necessary number of characters.
		for (var i = 0; i < (places - len); i++) {
			// If trailing is true, append the zeros; otherwise, prepend them.
			if (trailing) {
			 	filledVal += "0";
			} else {
				filledVal = "0" + filledVal;
			}
		}
		// Return the string.
		return filledVal;
	}
	
	// rounds a number to a specified number of decimal places
	// num   : The number to round
	// decPl : The number of decimal places to which to round num
	function roundDecPl(num:Number, decPl:Number):Number {
		// decPl defaults to 0 (round to the nearest integer).
		if (decPl == undefined) {
			decPl = 0;
		}
		// Calculate the value used to multiply the original number, 
		// which is 10 raised to the power of decPl.
		var multiplier = Math.pow(10, decPl);
		// Return the result.
		return Math.round(num * multiplier ) / multiplier;
	}
	
	// formatNumber
	// num 	: The number you want to format
	// thousandsDelim : The value to use for delimiting the thousands, millions, billions, etc. places
	// decimalDelim   : The value to use for delimiting the decimal places
	// spaceFill      : Specifies the number of total spaces the formatted string should occupy (optional)
	function numberFormat (num:Number, thousandsDelim:String, decimalDelim:String, spaceFill:Number):String {
		// Default to a comma for thousands and a period for decimals.
		if (thousandsDelim == undefined) {thousandsDelim = ",";}
		if (decimalDelim   == undefined) {decimalDelim= ".";}
		// Convert the number to a string and split it at the decimal point.
		var parts = String(num).split(".");
		// Take the whole number portion and store it as an array of single characters. 
		// This makes it easier to insert the thousands delimiters, as needed.
		var partOneAr = parts[0].split("");
		// Reverse the array so we can process the characters right to left.
		partOneAr.reverse(  );
		// Insert the thousands delimiter after every third character.
		for (var i = 0, counter = 0; i < partOneAr.length; i++) {
			counter++;
			if (counter > 3) {
				counter = 0;
				partOneAr.splice(i, 0, thousandsDelim);
			}
		}
		// Reverse the array again so that it is back in the original order.
		partOneAr.reverse(  );
		// Create the formatted string using decimalDelim, if necessary.
		var val = partOneAr.join("");
		if (parts[1] != undefined) {
			val += decimalDelim + parts[1];
		}
		// If spaceFill is defined, add the necessary number of leading spaces.
		if (spaceFill != undefined) {
			// Store the original length before adding spaces.
			var origLength = val.length;
			for (var i = 0; i < spaceFill - origLength; i++) {
				val = " " + val;
			}
		}
		// Return the value.
		return val;
	}
	// -----  -----	
	public function trimSpacer(str:String):String {
		if (str == "") return "";
		for (var i:Number = 0; i < str.length && (str.charAt(i) == ' ' || str.charAt(i) == '\n' || str.charAt(i) == '\t' || str.charAt(i) == '\r'); i++);
		for (var j:Number = str.length - 1; j >= i && (str.charAt(j) == ' ' || str.charAt(j) == '\n' || str.charAt(j) == '\t' || str.charAt(j) == '\r'); j--);
		return str.substring(i, ++j);
	}
}
    

