-- MySQL dump 10.9
--
-- Host: localhost    Database: realestate
--
-- Table structure for table `listing`
--

DROP TABLE IF EXISTS listing;
CREATE TABLE listing (
  mls_id varchar(10) NOT NULL default '',
  address varchar(100) default NULL,
  city varchar(50) default NULL,
  state char(2) default NULL,
  zipcode varchar(5) default NULL,
  `status` varchar(10) default NULL,
  price decimal(19,4) default NULL,
  bedrooms smallint(6) default NULL,
  bathrooms double default NULL,
  stories varchar(50) default NULL,
  footage int(11) default NULL,
  yearBuilt int(11) default NULL,
  `type` varchar(50) default NULL,
  listedOn datetime default NULL,
  hasPool tinyint(4) default NULL,
  hasLaundry tinyint(4) default NULL,
  hasFireplace tinyint(4) default NULL,
  hasWalkInClosets tinyint(4) default NULL,
  remarks longtext,
  PRIMARY KEY  (mls_id)
) TYPE=MyISAM;

--
-- Dumping data for table `listing`
--

LOCK TABLES listing WRITE;
INSERT INTO listing VALUES ('A29345','6520 Arboleda St','City Terrace','CT','92517','active','295000.0000',2,1,'1',800,1970,'Multi-Family Home','2005-10-03 00:00:00',0,1,1,0,'$30,000.00 Price Reduction! Nice Private Location! Views! Near Schools. Good home for 1st time buyer. Newer Electrical Upgrade. Located in City Terrace.'),('A454528','P O Box 3877','Ontario','MO','91761','active','495999.0000',2,1,'1',950,1975,'Multi-Family Home','2005-10-03 00:00:00',1,1,0,0,'Price Slashed. Bring all offers. Ask about upgrade allowances for flooring. 2 bedroom 2 bathroom in gated community with gas fireplace in living room, dishwasher, garbage disposal. Montessori school, children\'s playground, 24-hour security, serene, peaceful environment, 3 pools, rec. room, exercise room, tennis courts, conference room covered and secured garage. Near Promenade & Fox Hills Mall. Close to 405 and 90 frwy and beaches. Seller\'s choice of services.'),('A674464','1966 S. Date St.','Bloomington','AZ','92316','active','760000.0000',3,2,'1',1240,1987,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'Great townhome is superb location near shoping centers, 2 miles to the beach. Nice size patio area for your guests and BBQ. Big formal dining room,and large living room w/ fire place that exits to patio. Master suite plus 2nd bedroom upstairs (Option forl 3rd bedroom) Comfortable kitchen with attached laundry room. This unit also has an attached private 2 car garage. Feels like a house.4 pools in the complex. Bring on the OFFERS !!!!!!!!!!!'),('A769087','1893 Capri Ave #G','Mentone Beach','CA','92651','active','3000000.0000',4,4,'2',2500,1995,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,1,'Hard-to-come-by \"E\" plan end unit in quiet Highlands complex. Multi-level townhome w/lrg, open living room w/fireplace & patio, dining overlooking liv rm, bright, eat-in \"country\" kitchen. Three bedrooms upstairs. Very large master w/vaulted ceiling & balcony. Fabulous designer colors. Peaceful outlooks of trees & mountains. Only one common wall. Community pool, tennis, gym. Close to hiking trail access. Also available for lease at $3,600/month.'),('A87324','5876 South Parkway','Santa Ana','CO','92705','active','265000.0000',2,1,'1',795,1999,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,1,'Excellent Location!!!Private Top Level Unit in Oak Hills Gated Community.Priced Low for Quick Sale!!! This Condo has an open floor plan and Cathedral Ceilings. Newer Carpet and Paint. This Condo is a Must See!!'),('A87343','87233 S. Nayee','Anaheim','CA','92653','recent','419900.0000',2,2,'2',950,1985,'Multi-Family Home','2005-10-03 00:00:00',1,0,1,0,'Turnkey single story upper end unit with slate floors, neutral decor,custom window coverings and blinds. This beautiful unit in a gated community is the ONLY ONE IN TRACT WITH TWO BATHS AS OF LISTING DATE, 9/13!Kitchen and bath Also been upgraded. Beautiful mirrored wall and closet doors. Bright and cheery. Also has a patio off entryway as well as a balcony off master bedroom.'),('B23232','14643 rancho vista dr','San Diego','CA','92335','active','654000.0000',3,3,'2',1140,2000,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'Marina View Condo in the heart of a wonderful beach community. Resort style living at its best, easy and very close access to all the pleasures Marina del Rey offers. Unit has been nicely upgraded, new fixtures, fresh paint, kitchen upgrades and what a view! Complex offers great amenities. Very easy to show.'),('B324234','9119 Schaefer','Ontario','DC','','backUp','305900.0000',2,1,'2',800,1991,'Multi-Family Home','2005-10-03 00:00:00',1,1,1,0,'TWO BEDROOM, 1 BATH,CLEAN KITCHEN, LAUNDRY ROOM, MASTER BEDROOM HAS LARGE WALK-IN CLOSET, ATTACHED GARAGE THAT FITS TWO CARS TANDEM, ACCESS TO POOL, PRIVATE PLAY AREA AND BARBEQUE AREA. NEXT DOOR TO CAL STATE LA. CONDO COMPLEX IS IMMACUALTE. FRESHLY PAINTED, CARPET 1 YEAR OLD, COMES WITH REFRIGERATOR, STOVE, DISHWASHER, AND CLOTHES DRYER. CENTRAL AIR AND HEAT'),('B343523','8945 Ottawa St.','Los Angeles','CA','90058','active','294000.0000',1,1,'2',565,1989,'Multi-Family Home','2005-10-03 00:00:00',0,1,0,0,'THIS IS A 100 UNIT CONDO CONVERSION PROJECT BUILT IN 1989 ORIGINALLY AS CONDOS. NEWLY RENOVATED INTERIORS AND EXTERIORS. DECORATED MODELS AVAILABLE FOR VIEWING. '),('B435465','3346 Queen St.','Corona','AZ','92882','active','775000.0000',3,2,'1',1290,2004,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'CHIC BRITE & SPACIOUS \"G\" PLAN TOWNHOME IN VILLA VALLARTA. HI CEILINGS & FRPL IN LIV. RM. NEWLY PAINTED, WOOD-LOOK FLRS, GOURMET KITCHEN W/BREAKFAST AREA, PLANTATION SHUTTERS, RECESSED LIGHTING & MORE! 2 MASTER SUITES & LOADS OF CLOSET SPACE. LGE. PATIO & DIRECT ACCESS GARAGE. ENJOY A RESORT LIFESTYLE IN A GATED COMMUNITY W/POOLS, SPAS & RACQUETBALL.'),('B45453','8740 E. 8th Street','Corona','MT','92879','recent','505000.0000',2,2,'2',1055,1992,'Multi-Family Home','2005-10-03 00:00:00',0,1,1,1,'ocated in the very desirable Raintree! A top floor corner unit w/only 1 shared wall, this wonderful condo is 1322sf, has 2 bdrms, 2 ba, & a den, w/cedar closets in both bdrms. The den can be used as an office or third bdrm w/its built-in bookshelves & closet. New tile extends from the dining area into the kitchen & breakfast nook that were recently remodeled w/black granite counters & new wood cabinets. Must see! 1st showing Broker\'s Caravan, 9/20, from 11-2, then by appt. only. Offers by 9/23'),('B654766','8482 Cherry Ave','San Diego','CA','92335','active','125000.0000',1,1,'1',650,1970,'Multi-Family Home','2005-10-03 00:00:00',0,0,0,0,'Fixer or remodelers project. Large front unit w/ 34\' wide patio & 1,345 sq.ft. Charming building with brick courtyard & lush landscaping. Open floor plan w/ spacious living room & dining area. Wood burning brick fireplace. Washer/dryer hook-ups. 2 car parking. Combo Lock box.'),('C23465','9874 8th Street','Fort Mohave','CA','86427','recent','310500.0000',2,1,'1',840,1982,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'Newer Spanish Hacienda home done to perfection! Grt open gourmet kit to DR w/French drs facing lg front patio for entertaining w/beautiful LR & FP. Upstairs is master ste w/pvt ofc, vaulted ceilings, built-ins & custom bath w/tub & steam shower & windows galore! Downstairs are 2 bedrooms w/den facing the back of the house with pool, spa & GH (garage conv w/out permits). Property is gated, pvt & driveway can hold 3 cars.'),('C303434','13450 West Perioria','Surpirse','CA','85379','recent','510000.0000',2,2,'2',1060,1976,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'NEW CARPET, PAINT AND DISHWASHER. HOA INCLUDES CABLE TV, GAS AND WATER.GREAT COMPLEX WITH 3 SWIMMING POOLS AND MONTESSORI SCHOOL ON PREMISE.BUYER TO TO COOPERATE WITH SELLERS TAX FREE EXCHANGE AT NO COST TO BUYER. OWNER HAS CALIFORNIA REAL ESTATE LICENSE. NO SHOWINGS BEFORE BROKER\'S OPEN HOUSE ON 9/20. PUBLIC OPEN HOUSE 1-5 ON 9/25. ALL OFFERS TO BE REVIEWED ON 9/26.'),('C345344','1324 W. 166th Street','Gardena','NV','90247','active','299999.0000',1,1,'1',728,1973,'Multi-Family Home','2005-10-03 00:00:00',0,1,0,0,'SO GORGEOUS!!! DON\'T MISS IT! LARGE UNIT. Decorator\'s masterpiece: custom paint, white cabinets, granite bar, tract lighting, tile floors, beautiful carpet. Great location by greenbelt, total privacy. LARGE PATIO. Whole complex just got a facelift.'),('C465466','425 WILSON ST','Redwoods','AZ','92376','recent','782000.0000',2,2,'2',1500,1988,'Single Family Home','2005-10-03 00:00:00',1,1,0,1,'ADORABLE SINGLE FAMILY HOME ON A WONDERFUL RESIDENTIAL STREET IN THE FLATS OF MAR VISTA. 3 BEDROOM PLUS 1.5 BATHS AND A FAMILY ROOM. ENTRY LEADS TO WARM & COZY LIVING ROOM WITH WOOD FLOORS & WOOD BURNING FIREPLACE. GRASSY FENCED YARD. DETACHED ONE CAR GARAGE WITH OFFICE SPACE. 1ST SHOWING IS SUNDAY 9/11 FROM 2-5.'),('C878765','42021 E. Kay Lane','Maple','CA','92324','active','650000.0000',3,2,'2',1200,1992,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'Immaculate townhouse that has been completely remodelled with hardwood floors, granite kitchen, fireplace and wet bar, stainless steel appliances, air conditioning, washer, dryer and a woodburning fireplace. There is also an inside laundry room and two car garage. The community includes a heated pool, spa, tennis courts and a fitness room. Call for lock box.'),('C98345','8742 Almond St','San Diego','CA','92423','active','236999.0000',2,1,'2',756,1980,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'Fabulous bright unit in the prestigious Edgewater Towers features high ceilings, an open floorplan, & a wonderful large patio yard good for gardening or pets. Amenities in this resort style complex include pool, tennis courts, hiking trails, & 24 hour guarded entry. Homeowner\'s fees include electric, water, trash, gas & EQ insurance. Close to Pacific Ocean.'),('C987650','1225 West Imperial Hwy.','Los Angeles','CA','92821','active','250000.0000',1,1,'2',760,1985,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,1,'GORGEOUS TOP FLOOR CONDO WITH MILLION DOLLAR CITY/TREE TOP VIEWS! TURNKEY CONDITION SO MOVE RIGHT IN! NEWLY REMODELED & SPARKLES WITH BRAND NEW PAINT, BRAND NEW CARPET, BRAND NEW VERTICALS, & SO MUCH MORE! GOURMET KITCHEN OFFERING BRAND NEW FLOORS, NEWER STOVE & SLIGHTLY USED FRIDGE! COMMUNITY POOL, GARAGE, & PRIVATE BALCONY. DESIRABLE BALDWIN HILLS LOCATION! ONLY AVAILABLE UNIT ON THE MARKET SO HURRY!!! THIS HOME WILL NOT LAST!'),('D087877','2213 N. Tyler Ave','Mar Vista','CA','91733','active','305000.0000',2,1,'1',850,2001,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'Move right in! Large 2 bedroom townhouse with only 5 units in complex featuring - gas fireplace, recessed lighting and new hardwood floors in living area, newly tiled kitchen & bathroom floors and recent fresh paint throughout. Two outside patio areas downstairs, plus balcony off upstairs master bedroom. Each bedroom has its own private full bathroom. Inside laundry and two side-by-side parking spaces in secured, gated complex. Only blocks to beach, 3rd Street Promenade, SMC & Main Street.'),('D324325','2194 MCKINLEY #D','Marina del Rey','CO','92404','backUp','350000.0000',1,1,'2',1100,1985,'Condo/Townhouse','2005-10-03 00:00:00',1,0,0,1,'Turnkey 1 bedroom charmer nestled in a prime gated community. Interior is clean throughout with scraped ceilings, mirrored, dining room, and upgraded carpet. Cozy patio with view of greenery.'),('D343731','742 E. Frontera Street','Long Beach','MT','90810','active','523000.0000',3,2,'1',1070,1993,'Multi-Family Home','2005-10-03 00:00:00',0,1,1,1,'ADORABLE UPDATED CORNER 3 BEDROOM UNIT. LIGHT, QUIET & SPACIOUS. HW FLOORS, TILE PATIO, NEW BATH, BERBER CARPET. 2 CAR PARKING,. LOTS OF STORAGE. PERFECT MOVE IN CONDITION. HOA DUES INCLUDES WATER, GAS, SATELLITE DIRECT TV. NO SHOWINGS UNTIL SUNDAY OPEN HOUSE 8/28/02 FROM 2:00 PM TO 5:00 PM.'),('D565567','4505 Pacific Hwy. East Suite D-1','Tacoma','CA','98401','recent','795000.0000',4,3,'2',1250,2005,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'Beautiful and charming 4 bedroom home in Santa Monica\'s Sunset Park. This adorable house features an updated kit, hardwood floors, fp w/rebuilt chimney, new granite in bathroom & kitchen, new alarm system, Viking stove, an amazing professionally landscaped front & backyard w/ mature trees, new sprinkler sys., 100 amp electrical serv, new gas & sewer lines, copper plumbing, new Bryant Furnace, Huge flat lot over 7000 sq. ft. great add-on potential. Top Santa Monica school district.'),('D76854','10560 elm \"E\"','San Diego','DC','89652','sold','320000.0000',2,1,'1',865,1992,'Multi-Family Home','2005-10-03 00:00:00',1,0,1,0,'REAT OPPORTUNITY FOR FIRST TIME HOMEBUYER! CUTE HOUSE AT TOP OF THE STREET. 2BD/1BATH WITH 1 CAR DETACHED GARAGE. CONVENIENTLY LOCATED NEAR SHOPPING AND MAJOR FWYS. WITH ADDED BONUS TO THE SUCCESSFUL SELLING AGENT THIS PROPERTY WILL NOT LAST!!!!!!!!CONTACT LISTING AGENT TO SEE THIS CUTE HOUSE FROM THE INSIDE!!!!!!!!!!!'),('D87624','14085 Valley','San Diego','CA','','active','502000.0000',2,2,'2',1250,1978,'Single Family Home','2005-10-03 00:00:00',0,0,1,0,'Desirable highlands unit priced to sell!!! 2 bd 2 ba with extra bonus room. Washer/Dryer hookups. Patio. Fireplace in living room. Mountain Views. Needs cosmetic work. First showing Tuesday Sep. 6 open house 11-2. Seller to select all services.'),('E179654','14801 Slover Avenue','San Diego','DC','92335','backUp','325000.0000',2,1,'2',800,1980,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,0,'WELCOME TO THIS GORGEOUS CONDO IN WOODLAND HILLS, A MUST SEE. NEAR ALLAMMENITIES. NEWER CARPETING, REDONE BATHROOM, LARGE BALCONY,GATED COMMUNITY. THIS LOWER UNIT SHOWS WELL. THERE ARE 2 SPAS, POOL, AND WORKOUR REC ROOM.'),('E56324','86475 Vista Del SUr','Coachella','AL','54829','active','986000.0000',3,3,'3',1450,2002,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'YOU WON\'T FIND SUCH A PRISTINE 4 BED HOUSE IN THIS PRICE RANGE! THIS HOME HAS A WONDERFUL LAYOUT W THE DOWNSTAIRS FEATURING AN UPDATED EAT-IN KITCHEN W GRANITE COUNTERS, DINING ROOM, LIVING ROOM W MARBLE FIREPLACE. ALL ACCENTED W WOOD FLOORS, TILE, HI CEILINGS & PLANTATION SHUTTERS. UPSTAIRS FEATURES A FAMILY ROOM, HUGE BALCONY W/ TREETOP & MOUNTAIN VIEWS, LRG WINDOWS & SKYLIGHTS THAT GIVE A BRIGHT & COZY AMBIENCE. GRASSY YARD, BEAUTIFULLY LANDSCAPED, & BLOCKS TO MARINA SHOPS!'),('E67676','12141 Red Canyon','San Diego','CA','96547','active','899000.0000',4,3,'2',1410,1979,'Single Family Home','2005-10-03 00:00:00',0,0,1,0,'Open Sundays 1-4 until sold. 2 Story Designer\'s Dream featuring 3 Bed, 3 Bath + Den (pre-wired for home theater) and complete home office w/Steelcase desk. Venetian Gold granite throughout kitchen and baths, stainless appliances, custom walk-in closets, Mahogany hdwd floors, Somerly carpet, 2 fireplaces, 3 patios, Plantation shutters, hand-painted backsplashes and laundry rm w/custom cabinetry. Million dollar condo for $899k!'),('E694533','139 West Mindanao','Dana Point','CO','','active','912000.0000',2,2,'1',1340,1970,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'ATTENTION RECORD PRODUCERS AND POST-PRODUCTION PROFESSIONAL! THIS CHARMING MAR VISTA HOME BOASTS A GARAGE THAT WAS CONVERTED INTO A FULLY-EQUIPPED, HIGH-END PROFESSIONAL RECORDING STUDIO/POST-PRODUCTION VIDEO FACILITY. 3BD/1.5 BTH HOME IS INCREDIBLY BRIGHT AND HAS WOOD FLOORS THROUGHOUT, TILED KITCHEN, LANDSCAPED YARDS W/AUTOMATIC SPRINKLERS. REAR YARD HAS GRASS-LINED STEP STONES, LOUNGE AREA AND FIRE PIT. CALL LA RE: DISCLOSURES AND EXCLUSIONS.'),('E879874','3730 S. Kaily Ave.','Marina del Rey','CA','90601','recent','1005000.0000',5,5,'1',1460,2003,'Single Family Home','2005-10-03 00:00:00',0,0,0,1,'Beautiful patio home in popular Villa Marina East. Two story, very private, lots of light, great indoor/outdoor flow, large rooms, great closet space, beautiful hardwood floors, loft like home office with quality built ins, private 2 car garage w/ storage & more... Very desirable gated complex w/ pool & tennis courts. Excellent Marina del Rey location. Brokers Open Tues. 9/27, noon - 3, twilight open Tues. & Thurs 5 - 7.'),('E898933','1228 West Ave.','Newport','MT','91730','active','532000.0000',2,3,'2',1065,1977,'Multi-Family Home','2005-10-03 00:00:00',0,1,1,1,'2+2 master suites, spacious open floor plan, lite, brite south facing unit. Balcony open from LR and both BR. Fireplace, washer, dryer hookups in unit, guest parking, spa, EQ insurance, newer construction built 1990, smooth ceilings, recessed lights. Great Palms location. First showing Tues 9/13 11-2- twilight 5:00 -6:30 9/13. Open Sun 9/18 2-5. No showings before Tuesday 9/13 caravan. A must see!'),('F34344','301 Kansas st.','Redlands','CA','92373','active','102000.0000',2,2,'1',630,1981,'Multi-Family Home','2005-10-03 00:00:00',0,0,0,0,'ENJOY THE SERENITY OF THIS ENCHANTING SEASIDE CUSTOM COACH WITH TOP QUALITY UPGRADES. SPECTACULAR OCEAN VIEW FROM NEWLY REMODELED DECK. THIS DOUBLE-WIDE IN DESIRABLE TAHITIAN TERRACE IS IN MINT CONDITION & HAS ITS ALL-NEW CARPET, NEW ENTRY WAY, UPDATED KITCHEN, CROWN MOLDINGS, 2 CAR CARPORT, 2 BR + 1.75 BATHS + BONUS RM/DEN/OFFICE. LOCATED ACROSS FROM OCEAN, IT IS TRULY RESORT LIVING AT ITS FINEST. COMMUNITY POOL, SPA, CLUBHOUSE, GYM. A PERFECT CONDO ALTERNATIVE, 55 YRS & OLDER ONLY PARK.'),('F345345','54114 Las Fuentes Road','Santa Fe Springs','CA','','active','305000.0000',1,1,'1',750,1974,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'Beatifully remodeled 1 BR, 1 BA condo. Home features completely renovated bathroom with upgraded tub. Newer laminated flooring in bedroom and living room. Newer tile in bathroom and kitchen. Newer plumbing system. Home features a front and back patio area. Light and Bright Kitchen with ceiling fan in eating area. Rare unit with laundry area (newer washer & dryer is optional & negotiable). Close to the Beach. Carport.'),('F395649','13373 Napa St.','San Diego','CA','','recent','315000.0000',2,1,'2',850,1970,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'BEAUTIFUL TRIPLE WIDE ON A QUIET CUL-DE-SAC STREET, WITH REMODELED KITCHEN AND BATHS, LIGHT & BRIGHT OPEN FLOOR PLAN, HIGH CEILINGS, OFFICE, BAMBOO FLOORS, PANTRY, CUSTOM CLOSETS, SPACIOUS MASTER SUITE AND A NICE FENCED YARD. ENJOY RESORT STYLE LIVING IN THE EXCLUSIVE POINT DUME CLUB WHICH OFFERS GUARD GATES, POOL, CLUB HOUSE, TENNIS COURTS AND YOU CAN WALK TO THE BEACH! PRICED TO SELL. HOD TO NEW OWNER WILL BE $1,921.00'),('F4534543','4543 Tree Rd','Laguna Beach','CA','92351','active','700000.0000',3,2,'2',1050,1970,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'Price Reduction! Fabulous loft style townhome beautifully remodelled throughout, mountain views, gourmet kitchen complete with stainless steel appliances, high ceilings, master bedroom with walk-in closet, gorgeous tile floors throughout, patio with fountain, located in lower woodies, HOA includes membership to Santa Ynez Rec Center includes pool, tennis and gym facilities, lovely lush landscaping, Must see!'),('F454568','1401 CLEVELAND AVE','NATIONAL CITY','AZ','91950','active','803000.0000',3,3,'2',1270,1989,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'DRAMATIC, BRIGHT, OPEN, DESIGNER TOWNHOUSE WITH WONDERFUL ATTENTION TO DETAIL. MAGNIFICENT ROSEWOOD FLOORS, REMODELED GOURMET KITCHEN W/BLK GRANITE COUNTERS. QUALITY BLACK PORCELAIN FLRS IN KITCHEN AND ENTRY. HI CEILINGS IN L/R, MASTER BEDROOM. GAS/WOOD BURNING F/P, ALL SMOOTH CEILINGS W/MANY FANS OFFERING AN UPSCALE STYLE OF LIVING. WELCOMING LUSH/TROPICAL PATIO FOR THOSE WARM NIGHTS TO BBQ OR RELAX. LAUNDRY ROOM, DIRECT ACCESS GARAGE. REDUCED FOR QUICK SALE!! OPEN TUES 9/20 11-2 & SAT/SUN 2-5'),('F63455','741 Alejandria Ave.','Culver City','CA','91746','active','1060000.0000',3,3,'2',1430,1982,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'Elegant & stylish 3BD/3BA recently remodeled w/ attention to detail. This move-in ready home has recessed ltg, crwn mld, and berber crptng w/ generous size LR/DR & FR w/stone fp providing an open floor plan-perfect for entertaining. Kit has European style cabinets, ceramic floor & adj lndry rm. Home has sec syst. Private rear wrap-around deck w/hot tub, beautiful landscaping with sprinkler system & Circular carport. Get the kids to SM schools! Seller selects services.'),('F785534','8471 Tulipe St.','Redondo Beach','NV','92833','active','540000.0000',2,2,'1',1086,1994,'Multi-Family Home','2005-10-03 00:00:00',1,1,1,1,'Updated Unit, 2+2 at Marina Gateway. One of Largest floor plans in complex. Two large master suite\'s with extra walk-in closet. One bedroom has separate outside entrance. New tile, bathroom fixtures and plantation shutters. Two-car parking close to entrance & elevator. Laundry on each floor. Secure bldg w/Pool, Rec. Rm, Spa, etc. Incredible Location - close to Marina, Stores & Fwy. Easy to show, call agent, by appt. w/tenant.'),('F87343','14557 randall ave','San Diego','CA','92335','active','1070000.0000',4,3,'1',1470,2004,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'GREAT LOCATION ON QUIET MAR VISTA CUL-DE-SAC STREET. IMMACULATE 4BR + 3BA WESTCREST TRADITIONAL + SPACIOUS PANELED FAMILY ROOM. UPDATED KITCHEN WITH BUILT-INS. REAR FACING LIVING ROOM WITH DIRECT ACCESS TO LUSH, PRIVATE BACKYARD AND PATIO. VIEW POTENTIAL FROM ROOF. BUILD A SECOND STORY AND SEE CLEAR TO THE MARINA!'),('F984418','19822 Mira Loma','San Bernardino','CA','91701','sold','330900.0000',2,1,'2',960,2000,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'COME ENJOY THE COVE! WALK TO BEACH AND RESTAURANT. BEST SURF SPOT & TIDEPOOLS. VERY SPECIAL LOCATION. LOWEST PRICE AROUND, NEEDS SOME TLC. WIDE FRONT PORCH FOR ENTERTAINING AND BARBEQUE. ROOM TO EXPAND ON SIDES AND BACK AREA. LARGER SPACE THAN MANY. PRESENT UNIT IS 14\' X 40\'. LOW SPACE RENT. MAKE THIS YOUR WEEKENDER GET-A-WAY'),('G188454','13190 Whittram Ave.','Newport','FL','91739','sold','340900.0000',2,1,'2',870,1983,'Condo/Townhouse','2005-10-03 00:00:00',0,1,1,1,'UPGRADED 2+1 UNIT IN N. HOLLYWOOD COMPLEX WITH SPACIOUS LIVING RM*HARDWOOD FLOORS*TILE IN THE KITCHEN & BATH*LOTS OF CABINETS & STORAGE SPACE*LOCATED ON FIRST LEVEL (COOL SUMMERS)*PRIVATE BACK UNIT IN GATED COMMUNITY W/POOL & REC ROOM/PLAYGROUND'),('G35343','1431 W. Manhattan Street','Corona del Mar','CA','92311','backUp','1500000.0000',3,2,'2',1490,1983,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'Prime North Kentwood location. 3 Bdrms 1.75 baths and Family room w/ fireplace leading to large beautiful back yard also with fireplace. Formal Dining Room and Isolated Living room w/ fieplace and Picture Window. Large updated kitchen with Eating Area. Hardwood floors, Copper plumbing and New Forced Air Heating. 2.5 car Garage. New Paint inside and outside. A must to see, move-in condition.'),('G45324','7741 N. Alameda St.','Los Angeles','CA','90001','active','215900.0000',2,1,'1',770,2005,'Multi-Family Home','2005-10-03 00:00:00',0,1,0,0,'BACK ON MARKET! SELLER HAS MOVED-BRING ALL OFFERS! Remodeled single level unit w/maple wood flrs,crown molding & plantation shutters thru-out. Recessed lighting,fireplace & treetop views from living rm. Light & bright,open spacious flr plan w/European cabinets & silestone counter tops in kitchen.Terra cotta flrs in dining and kitchen.Washer/Dryer in unit. Large master walk-in closet.Walk to Village,Farmer\'s Market & Hiking Trails.Building has EQI. $3600 credit towards homeowners dues.'),('G565635','2100 North Alameda','San Clemente','NM','54685','active','545000.0000',2,4,'1',1090,1978,'Single Family Home','2005-10-03 00:00:00',1,1,1,1,'Great Neighborhood! House is located at the end of Cul-De-Sac. Alley acess drive thru carpot with access to a two car garage room for R.v. and Boat. Quite location by Marina 10 minutes to Playa Del Vista and Marina Del Ray. Home show wells it has been well cared for Harwoods floors and freshly painted. Please note lot size per assesor show 3600sqft but lot size is 46x154x36x160 to is approx 6000 sqft'),('G657343','8750 Monte Vista Ave','Corona del Mar','CA','91763','active','324900.0000',1,1,'1',708,1985,'Condo/Townhouse','2005-10-05 00:00:00',1,1,0,1,'Wonderful unit with open kitchen and large dining area. Refreshing patio just sit back, relax and enjoy the summer breezes. Large 1 car garage, A/C, Includes Washer/Dryer inside unit, low HOA dues. Close to shopping and restraunts. Popular lower unit in gated community. Well maintained, private location close to the toll road and near the 5 freeway. Association fee includes water, trash and private park with tennis courts.'),('G674447','1230 Railroad Street','Corona','CO','92882','recent','814600.0000',3,2,'2',1260,1990,'Condo/Townhouse','2005-10-03 00:00:00',0,1,1,1,'Move in condition home in prime Mar Vista location. Hrdwd floors, Very Privat backyard, New windows, Large Family room, This house screams pride of ownership. Very quiet family neighborhood. Beautiful brickwork throughout the property. Over 1400 sqft per seller buyer to verify. Open Sunday 8/01/2005 from 2-5'),('G790475','2038 S Sycamore','Bloomington','CA','92316','backUp','275000.0000',2,1,'2',960,1986,'Condo/Townhouse','2005-10-03 00:00:00',1,0,0,1,'Architectually designed end unit townhome. Dramatic skylights complimenting cathedral ceilings. Gracious, open floor plan. Custom built-in cabinetry thoughout all living areas & closets maximize functionality and style. Chef\'s kitchen. Built-in sound. First class finishes of Spanish pavers, wood and tile creates a blend of beauty and warmth. Extra large patios off living room and master. Separate laundry room, 2 car private/covered garage. Beautifully landscaped. Ideal location.'),('H658976','1495 Columbia Ave.','Riverside','AZ','92507','active','1600000.0000',3,3,'1',1480,1980,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'!! LOCATION!! !!LOCATION!! !!LOCATION!! BEAUTIFUL,TREE-LINED STREET IN WESTDALE TROUSDALE AREA OF MAR VISTA. 3 BDRMS+2.75 BATHS. LIVING ROOM W/FPLC+FAMILY ROOM COMBINATION WITH SKY LIGHTS. FORMAL DINNING ROOM. SPACIOUS LANDSCAPED BACK YARD WITH ENTRY FROM FAMILY ROOM. CARPET FLOORS. ENLARGED UPDATED KITCHEN WITH BREAKFAST AREA AND ADJOINING LAUNDRY ROOM. CENTRAL AIR & HEATING.'),('I986067','7444 Loro Rd','Apple Valley','CA','92308','recent','623000.0000',3,3,'2',1230,1984,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'CHARMING BEACH COTTAGE. LIGHT & BRIGHT WITH SKYLIGHTS, HARDWOOD FLOORS, PLANTATION SHUTTERS, DECORATOR TILES, LEADED GLASS, FRENCH DOORS TO BACK DECK OVERLOOKING THE CREEK & THE OCEAN. GOLF CART INCLUDED.'),('J334566','233 South Marshall Ave','Laguna Beach','CA','92020','sold','343000.0000',1,1,'1',683,1986,'Condo/Townhouse','2005-10-04 00:00:00',1,1,0,1,'Turnkey 1 bedroom charmer nestled in a prime gated community. Interior is clean throughout with scraped ceilings, mirrored, dining room, and upgraded carpet. Cozy patio with view of greenery.'),('J3464470','8541 Arrowhead Ave','San Diego','CO','92337','active','820000.0000',3,2,'2',1290,1971,'Single Family Home','2005-10-03 00:00:00',0,1,1,1,'EXPERIENCE THE CHARM OF THIS RECENTLY REMODELED HOME IN LINDBERG PARK. FEATURING NEW KITCHEN, GRANITE COUNTERS, NEW APPLIANCES, NEW BATHS, NEW ROOF, NEW PAINT, REFINISHED HARDWOOD FLOORS, NEW WINDOWS, CAT5 WIRING. RELAX IN THE RECENTLY LANDSCAPED YARD. LIGHT & BRIGHT IN EVERY ROOM. CONVENIENTLY LOCATED NEAR RESTAURANTS, STORES & THE MARINA. OPEN 9/20 11-2PM & 9/25 2-5PM.'),('J45473','741 South Gayle Ave.','Pomona','AZ','91766','active','1700000.0000',3,2,'2',1500,19970,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'Want to walk to Abbot Kinney? You can! Or just stay home and relax in your 3 bedroom house with wood floors throughout. Curl up beside the fire place in your living room or take sun on your deck leading to a spacious garden. OH: Sunday 9/25 2-5, then Tue 9/27 11-2.'),('J674436','1021 Pearl St','Newport','OH','93214','active','620000.0000',2,2,'2',1115,1995,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,1,'CHARMING COUNTRY ENGLISH 2-STORY TOWNHOMW (END UNIT) IN SMALL 6-UNIT BUILDING. THIS SPACIOUS HOME FEATURES 2 SEPARATE BEDROOM SUITES, LARGE LIVING ROOM WITH WOOD BURNING FIREPLACE ALONG WITH DIRECT ACCESS FROM PRIVATE 2-CAR GARAGE. FABULOUS PRIVATE PATIO OFF LIVING ROOM, PRIVATE LAUNDRY, SKYLITES, SECURITY SYSTEM. GREAT EXTERIOR APPEAL! 24 HOUR NOTICE TO SHOW PLS.'),('J765976','3231 Lorraine Rd','Corona del Mar','CA','90311','sold','135000.0000',1,1,'1',715,1963,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Great opportunity. Tiny house, big lot. Charming & private setting off Las Pulgas Canyon. Popular Pacific Palisades neighborhood. Amazing chance to build in P.P. either now or later. Do not disturb tenants! Adjacent property also available, see MLS # 05-029831.'),('K123214','3840 Wacker Drive','Mira Loma','CA','91752','sold','310000.0000',2,1,'1',1030,1971,'Multi-Family Home','2005-10-03 00:00:00',1,1,0,0,'THIS COVE CHARMER HAS BEEN COMPLETELY REBUILT FROM THE GROUND UP. NEW PLUMBING, NEW ELECTRICAL, NEW BATHROOM W/ GORGEOUS TILE WORK, KITCHEN W/ TUMBLED STONE COUNTERTOPS, TOP OF THE LINE APPLIANCES, BEAUTIFUL CABNITRY. PINE FLOORS IN LIVING RM W/ CARPET IN BDRS. TWO OF THE BDRS HAVE SLEEPING LOFTS TO INCREASE LIVING SPACE. LOCATED IN THE BEACH SECTION JUST A SHORT STROLL TO THE SAND. LOW SPACE RENT. GREAT FOR FULL TIME OR USE AS A WEEKENDER.'),('K3344189','1587 Bentley Dr #101','Corona','FL','92879','active','350999.0000',2,1,'1',896,1995,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'NICE CONDO,IS VACANT READY TO MOVE IN,THIS WILL GO FAST. PROPERTY IN PERFECT CONDITION. !!!!!!!!I SEE YOU IN ESCROW !!!!!!!'),('K342786','1221 South G Street','Perris','CA','92570','active','349000.0000',1,1,'2',710,1985,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,0,'Location, Location, Location! You can\'t beat this one, directly across from the pool and spa area. One of the best locations in the tract. Upgraded ground level unit with nice patio. You will love how this home shows. Newer carpet and new paint, mirrored wardrobes,A/C, new kitchen stove and range, gorgeous tile floors in entry, kitchen, and dining areas. All this plus it is in a gated community. Laundry is inside the unit (washer/dryer/refridgerator included!!),private park and tennis courts'),('K34334','1800 S. Avalon Blvd','San Clemente','AZ','90220','active','1800000.0000',5,5,'1',2100,1972,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'Very special 2-story 1925 classic w/original details ... fireplace, windows, doors, arches & coved ceilings! Warm oak & fir floors! Lushly landscaped front yard! Grand front porch! Bright, cheerful living room! Formal dining room opens to side courtyard! Charming kitchen w/vintage stove & sunny breakfast nook! Fenced backyard w/dining patio, large grassy area, mature plantings! Huge garage/studio w/ 1/2 bath ... terrific for art studio or home workshop ... plenty of parking in the driveway!'),('K4334673','10311 6th Street','Mar Vista','CO','95826','recent','840500.0000',3,3,'2',2000,1973,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'GREAT FAMILY MAR VISTA HOME IN PRIME CORNER LOCATION. SUNNY LIVING ROOM W/ FIREPLACE, BAY WINDOW, HARDWOOD FLOORS, AND CROWN MOLDINGS. COMPLETELY REMODELED KITCHEN LEADS TO FORMAL DINING ROOM. REMODELED BATHROOM MASTER BATH W/ GLASS SHOWER ENCLOSURE. HUGE PRIVATE BACKYARD W/ BUILT IN BBQ AND TWO PATIOS! LOVELY LANDSCAPING IN FRONT AND BACKYARD. 2-CAR GARAGE. SELLER SELECTS ALL SERVICES. OPEN HOUSE SATURDAY & SUNDAY!'),('K467437','3250 Frontera Street','Anaheim','ND','89572','active','615000.0000',2,2,'1',1110,1979,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,1,'BEAUTIFUL, IMMACULATE TOWNHOUSE. LIGHT & SPACIOUS. FEATURES: HICKORY HARDWOOD FLOORS, SMOOTH CEILINGS THROUGHOUT, RECESSED LIGHTING, CROWN MOLDINGS, UPGRADED KITCHEN, AND QUALITY PAINT W/ DESIGNER COLORS. PRIVATE 2 CAR GARAGE WITH AN ABUNDANCE OF STORAGE. HEATED POOL. JUST A SHORT WALK TO SHOPPING, FOOD, MOVIES, AND THE BEACH!'),('K983434','1241 Alviso Ave','San Juan Capistrano','CA','92337','active','359900.0000',2,2,'1',1000,1973,'Condo/Townhouse','2005-10-03 00:00:00',0,0,0,0,'Popular Porch Entry 2 BR 2 BA Upper End-Unit in park-like community in the heart of San Juan Capistrano. Vaulted ceilings in LR & DR, skylight, family kitchen with viewing deck and bright eating nook, Master Suite has shower and walk-in closet. Ocean breezes, 5 min. to Salt Creek Beach, walk to shops, fitness center, library, and bus stop. Excellent school district.'),('KH454572','3401 Oso Drive','Denver','CO','92324','recent','830999.0000',2,1,'1',1280,1991,'Single Family Home','2005-10-03 00:00:00',0,1,1,1,'HIGHLY SOUGHT AFTER SPANISH ABODE TASTEFULLY REMODELLED ON TREE-LINED STREET. THIS LIGHT AND BRIGHT HOME FEATURES A NEW KITCHEN w/ stainless appliances & granite counter tops, NEW BATH, SITTING AREA IN THE MASTER BEDROOM w/ french doors leading to the backyard, AN OFFICE, and 2 CAR GARAGE. GLEAMING WOOD FLOORS, BEAMED CEILINGS, STAINED-GLASS WINDOWS, and METICULOUS LANDSCAPING. Great entertaining flow & family home! open Sunday, 9/18, 2-'),('L1905656','1700 W 5th Street','Glendale','IL','92405','backUp','360900.0000',2,2,'2',900,1984,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,0,'Located near the Center of Financial District Center in Glendale, Low HOA , . Close to shopping, restaurants, bank and freeways.Needs TLC'),('L34348','12450 Los Nietos Road','Santa Fe Springs','AZ','90670','sold','1900000.0000',3,2,'2',2500,1986,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'Elegant, remodeled top floor walk-street townhouse w/ ocean view. 2 Bdrms + Loft + Roof Top Deck. Lg. Liv Rm w/ oak floors, marble fireplace, vaulted ceilings & new oak staircase. Gorgeous Kitchen w/ top of the line stainless appliances, incl wine ref, maple cabs, granite counters & limestone floors. Spacious Master has oak floors, lots of closet space, balcony & limestone Mstr Bath. 2nd Bdrm has oak floors, skylights and beautiful bath with marble floors and spa tub. Laundry Rm inside.'),('L453338','8889 Etiwanda Ave','Newport','ND','91739','recent','612900.0000',2,3,'1',1100,1996,'Single Family Home','2005-10-03 00:00:00',1,0,1,1,'DISTINCTIVE CUSTOM 4 UNIT GATED BLDG, SMOKE FREE ENVIRONMENT. CHARMING 2 STORY TOWNHM. COUNTRY CASUAL-CITY CONVENIENCE. SPACIOUS LIVING/DINING RM WITH VAULTED CEILING. BRIGHT & AIRY. PRIV. SUNDECK W/PANORAMIC MOUNTAIN, OCEAN VIEWS. BRAZILIAN GRANITE WOOD BRNG. FIREPL. MULTIPLE LOFT SPACES FOR OFFICE, LIBRARY, GYM. PRIV. 2 CAR GAR. NEW DISHWASHER & STOVE. GREAT SUNSET PARK LOCATION. WALK TO SHOPS, PARK, RESTAURANTS, TRADER JOE\'S & STARBUCKS.'),('L653374','1230 Derst Dr','Dana Point','CA','92376','active','850000.0000',3,3,'1',2100,1992,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'A Spanish Delight. Brilliantly remodeled kitchen, living, dining and bathrooms. Gleaming wood floors, enchanting fireplace and high wood beam ceilings in living room and master bedroom. Upgraded windows, electrical and plumbing. Unique light fixtures located throughout. Large fenced back yard w/ fruit trees, brick fire pit and spacious covered tile patio. Detached garage. Open Sat 9/24 and Sun 9/25 from 2-5.'),('L902783','14515 whittram ave','San Diego','AZ','92335','active','200000.0000',2,2,'1',732,1974,'Multi-Family Home','2005-10-03 00:00:00',0,0,0,0,'GARDEN PATIO WALKWAY LEADING TO A STYLISH 2 BED, 2 BATH, MOVE-IN READY END UNIT. ONE COMMON WALL, HARDWOOD FLOORS AND CROWN MOLDING THROUGHOUT, LOVELY LIVING ROOM AND DINING AREA, INSIDE LAUNDRY, PATIO AND MANY UPGRADES.'),('L98345','14930 valley','San Diego','CA','92335','active','230900.0000',2,1,'1',745,1987,'Multi-Family Home','2005-10-03 00:00:00',0,1,0,0,'DRAMATIC HIGH CEILINGS WILL IMPRESS YOUR GUESTS. WALK-IN CLOSETS IN BOTH BEDROOMS, ONE WITH EN SUITE HALF BATH. WASHER DRYER HOOKUP IN UNIT. VERY LOW HOMEOWNERS DUES. NEW CARPET & PAINT. CALL AGENT FOR LOCKBOX COMBINATION. ** NO SHOWINGS AFTER 8:00 P.M. *** REMOVE SHOES.'),('M192453','11671 steling ave #1','San Diego','GA','','recent','370000.0000',2,2,'2',912,1985,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,0,'IMMACULATE - 2BDRM 2BTH, W/W CARPETING, CENTRAL AIR, INTERCOM FITNESSCENTER, COMMUNITY POOL, COMMUNITY LAUNDRY AND PLAYGROUND. THE OWNER ISIN THE PROCESS OF MOVING.'),('M27529','2601 County Road 700 East','Columbia City','IL','46725','sold','408000.0000',2,1,'1',960,1975,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,0,'Beautiful D Plan with central tiled atrium. New oven, cooktop, dishwasher. Also includes washer, dryer and built-in vacuum system. Cherry hardwood floors with marble insets and also carpeting. End unit with extra side windows. Poolside with lush landscaping. Roof will be totally replaced in September, assessment already paid.Seller selects services. Call L/A for showings. MUST SELL! Open House Sept.10th & 11th 2pm-5pm'),('M45444','6580 general','Riverside','NC','92558','active','240999.0000',2,2,'1',1200,1988,'Condo/Townhouse','2005-10-03 00:00:00',0,0,0,0,'Beautiful condo totally and recently updated, new tile flooring, new bathrooms and kitchen, you have to see it for yourself! Half bathroom on the first floor, full bath on the second. Perfect to rent the 2nd bedroom. Due to new updates we\'re asking cordially to remove your shoes, thanks.'),('M655375','233 Willow Street','Los Angeles','CA','90021','active','865000.0000',3,3,'2',1295,1972,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'Large lot in great neighborhood. 3 bedrooms and 2 baths. Not too pretty from the outside but lots going on inside. Great property to remodel for a large family home.Do not disturb tenant. Call listing agent for showings.'),('M87454','9841 Lyon Hwy.','Newport','OK','91730','active','625900.0000',2,1,'2',1150,1980,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,1,'This unit truly has it all, location on 3rd floor. Views of Marina, boats and greenbelt. Hardwood floors & tile. Extra-large skylight in dining area, recessed lighting, soaring high ceilings throughout, a nice open floor plan & 2nd bedroom converted into den. This unit is in move in condition and is bright and very spacious with enclosed balcony. Close to beach, shops & restaurants.'),('M9875','13052 Whittram Ave','Etiwanda','AZ','91739','recent','2100000.0000',3,3,'3',3000,1976,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'This classic, mid-century, retro/ranch styled fixer has unlimited possibilities. 5 minutes to the beach , this spacious 3bd 2ba with open floor plan, den, and non-permitted sun-room is waiting for your vision in this highly desirable, quiet, Venice neighborhood. Sold as-is buyer assumes all termite work, seller will make no repairs nor issue any credits.'),('N193453','13385 Estelle St','Corona','VT','92879','recent','375000.0000',2,2,'1',925,1996,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,0,'CHARMING CONDO! PERFECT STARTER HOME FEATURES 2 BDR, 2 BA, FIREPLACE IN LIVING ROOM, MASTER BDR W/WALK IN CLOSET, CENTRAL AIR, MOUNTAIN VIEWS, 2 CAR CARPORT AND IS LOCATED NEAR THE 405 FWY. SELLER RESERVES ALL SERVICES. PROPERY IS CONTINGENT ON SELLER FINDING A HOME OF CHOICE AND CLOSING CONCURRENTLY. SOLD AS-IS.'),('N529868','14642 Rancho Vista','San Diego','AZ','','active','2200000.0000',3,4,'2',2600,1989,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'3+3.5 CRAFTSMAN W/ REFURBISHED HARDWOOD FLOORS AND TILE FLOORS. NEWLY REPAINTED INSIDE & OUT. OPEN BEAM CEILINGS, LIGHT, BRIGHT AND OPEN FLOOR PLAN. ENCHANTING GARDEN W/ OUTSIDE BONUS OFFICE WIRED FOR CABLE. HUGE WOOD DECK. BONUS GUEST HOUSE W. 2+1, KITCHEN & LOFT SPACE. WALK TO TRENDY ABBOTT KINNEY & BEACH'),('N543576','8823 Rose Ave.','Dana','CA','96514','active','870000.0000',4,3,'2',1300,1993,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'Located in an absolute \"10\" location in the heart of North Kentwood! This lovely home features a cozy front porch and a peaceful shaded back yard. Enjoy a wood burning fireplace and gleaming hardwood floors. The entry way, laundry roon and breakfast nook make this a winning selection. 1031 tax exchange for the seller. Co-listed. Vacant. Call L/A for the combination.'),('N874540','2755 s willow ave','Bloomington','OR','92316','active','630000.0000',2,3,'1',1120,1997,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,0,'Very nice, gated home, with large sparkling pool and cabana / guest house in Culver City on large lot. Very bright, lots of windows! Fireplace in LR, breakfast nook, garden window in kitchen, hardwood floor in DR. One bedroom converted to den/family room. Great for entertaining. 2 car detached garage, large patio with built in BBQ, extra storage shed, solar heated pool. No showing until 10/4 Caravan. Public open on 10/9. Offers reviewed on 10/13.'),('N93443','10661 Etiwanda','San Diego','CA','92337','active','2500000.0000',5,4,'2',2700,1977,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'This charming 5 bd 4 ba home is 5 blocks from the beach and was one of the first homes ever built in the area. Step into a serene atmosphere, with coved ceilings in the living room, formal dining room, hardwood and tile floors throughout the home. French doors in the master bedroom and guestroom that lead out to a lush, private backyard, totally fenced, with a beautiful Koi pond. There is a spa off the deck and a detached studio/office in the back of the home. Spacious eat in kitchen.'),('O194454','508 Chaney Street Suite A','Lake Elsinore','IL','92530','sold','380000.0000',2,2,'2',930,1987,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,0,'Owner will consider helping buyer with Closing Costs. Wow. Great priced starter condo. very quiet comlex (only 44 total units). Sparkling Pool is perfect for this summer. 2 car detached garage is great for extra storage. This condo has a laundry area in unit.Bathroom has new tub,tile and shower hardware. Dining Skylight. Newly painted. Vacant!!!!!'),('O276238','13913 Ramsey Dr','La Mirada','CA','90638','active','3000000.0000',4,3,'1',3100,1990,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Hip Venice-Style Home in Great Santa Monica School District! This Chic Architectural home is situated on Ashland w/ a peek at the ocean. Tasteful accents of yellow polished wood cabs w/ cement counters in the kitchen and baths. Tub is a huge polised concrete mstrpiece. Int. flr is gorgeous with its polished wood creation. Frch windows and drs throughout the back deck and yard. Wonderful Indoor/outdoor liviing feel. Beautiful landscape sets this house apart from the rest.'),('O34741','874 Canyon Rd','Ontario','SC','91761','active','640200.0000',2,3,'1',1160,1981,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Stunning architectural in hip building. Open floor plan drenched in natural light. Living room with soaring ceilings, fireplace and hardwood floors. Spacious master suite with French doors, opening onto large private patio. Private 2-car garage and separate storage room. Home Owners Dues includes SBA loan of $20 per month.'),('O83443','8242 Goldmine Ave','San Diego','CA','92335','active','3500000.0000',7,6,'1',2800,1978,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'ENJOY SPECTACULAR SUNSETS, PANORAMIC CITY LIGHTS, MOUNTAIN & OCEAN VIEWS FROM THIS STUNNING HOME. PRIVATE DRIVE LEADS TO VERY ROMANTIC RETREAT IN A SERENE SETTING W/ PATIOS, FOUNTAIN, & LUSH, MATURE FOLIAGE. GORGEOUS, TOP OF THE LINE REMODEL W/ GOURMET KITCHEN, FAMILY ROOM & STUDY. LUXURIOUS MASTER SUITE W/ VAULTED CEILING. GREAT LOCATION FOR INDUSTRY PROFESSIONALS, , OR ANYONE SEEKING THE BENEFITS OF MINI-ESTATE LIVING. DESIGNED FOR INDOOR-OUTDOOR ENTERTAINING - VERY PRIVATE & SECURE'),('O845478','1240 S Lincoln St.','Denver','CO','92324','active','849000.0000',4,3,'1',1350,1973,'Single Family Home','2005-10-03 00:00:00',1,0,0,1,'Venice for under a Million$$ $849,000. Located blocks to the beach, this is a \'vintage\' Venice home with 2+1, bonus room and 2 car detached garage featuring hardwood floors, built-in \'china\' cabinet & possibility to build multiple units.'),('P196564','10836 Locust','Panorama City','IN','54625','active','390000.0000',2,2,'1',953,1986,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'2 BEDROOMS & 2 BATHROOM CONDO WITH LOW HOA FEES! IN PANORAMA CITY, CLOSE TO EVERYTHING!'),('P343466','7412 S Orange Dr.','New Life','NM','92334','active','250900.0000',2,1,'1',1100,1991,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,1,'Cheery 2 bedroom, 1 bathroom top floor unit with dining area open to living room. Cathedral ceiling and high windows in living room. Balcony, for relaxing after a long days work, off living room. Light and bright. 2 parking spaces. Complex has pool/spa, gym & sauna. Unit is located on south side by the gazebo.'),('P345632','3840 Wacker Drive','Mira Loma','CT','91752','sold','280000.0000',2,2,'1',830,1979,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,1,'Charming Calabasas Village. Large, private, fenced yard/garden, incredible mountain views and private location with a closed-in carport with automatic garage door. Near schools & \"The Commons\". 2 bedrooms, 2 baths + bonus room & island kitchen. Fireplace in den area. A must see!'),('P34763','8411 Ontario Ave.','Yorba Linda','CA','92887','active','4000000.0000',8,5,'2',2900,1992,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'RECENTLY UPDATED CHARMING TWO STORY TRADITIONAL HOME W/ GENEROUS SIZE ROOMS, WOOD PANELING & FLOORS. FRENCH DOORS THAT LEAD TO A PRIVATE PATIO & YARD. FORMAL DINING ROOM, FAMILY ROOM & BREAKFAST AREA ALL CONTRIBUTE TO A VERY FUNCTIONAL FLOOR PLAN FOR ENTERTAINING. CENTRAL AIR CONDITIONING, CLOSE TO SHOPPING & MOVE-IN CONDITION. A DEFINITE \"MUST SEE\"!'),('P43535','984 S Lake Street','Las Vegas','CO','89103','backUp','5000000.0000',6,3,'1',3450,1980,'Multi-Family Home','2005-10-03 00:00:00',1,0,0,1,'Silver Triangle. Stunning Contemporary incredible space and light in this unique, Architectural Residence. Three Bedrooms and three bathrooms plus loft, master suite with sunset views and triple glass sliding doors open to a large bali-style outdoor room with gas fire pit. Polished colored concrete floors, top of the line custom finishes throughout. One block to Venice canals. Square footage includes outdoor room off master. call listing agent 2 for showings.'),('P54645','1425 Cooley Court','San Bernardino','CA','','active','6000000.0000',7,8,'2',3500,1993,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'4+4 plus 2+1. Magnificent property in highly desirable \'Durley Park\' section of Venice. Huge 10,962 sq ft lot. Front house (1335 Vienna Way) 2-story 2749 sq ft. Downstairs: lv rm, dining, kitch, 2bd rm, 2 bath + office/nursery. Upstairs: 2bd rm + 2bath separated by lg family rm & kitchenette/dining area. Back stairway entrance, ideal for 2-generation family. Beautifully maintained guest house (1337 Vienna Way) 2bed, 1bath. Private yard. Additional studio. Quiet street in great neighborhood.'),('P63434','1401 N Mill St','Anaheim','CA','92806','active','7000000.0000',5,5,'3',3600,1981,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'CUSTOM BUILT ARCHITECTURAL 2 STORY HOME BUILT IN 2001 LOCATED IN THE BEST NEIGHBORHOOD IN VENICE. ADJACENT TO HISTORIC VENICE CANALS, WALK TO BEACH & MARINA. OAK HARDWOOD FLRS, VAULTED CEILINGS, GOURMET KITHCEN W/GRANITE COUNTERS, FIREPLACE IN LR & MASTER. DINING RM/FAMILY RM. TOTALLY WIRED FOR SOUND & INTERNET & SKYLIGHTS, ATTACHED GARAGE, SECURITY SYSTEM.'),('P735243','9133 Center Ave.','Newport','CA','91730','active','259000.0000',2,2,'1',825,1994,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,1,'Seller will entertain offers between 259,000 - 259,950. VERY NICE CONDO IN QUIET FAMILY ORIENTED NEIGHBORHOOD. NEAR ALL CONVIENCES. CLOSE TOSTORES & SHOPPING. EXCELLENT FOR 1ST TIME BUYERS OR PEOPLE WANTING TODOWNSIZE.'),('P769266','3351 Riverside Ave','Aliso Viejo','IL','92365','sold','350000.0000',2,1,'1',890,1982,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,0,'Beautiful Home in the Mar Vista AreaNewly painted exteriorFireplace in living roomHardwood floors throughoutFormal dining roomNew composition shingle roof100 amp Main circuit breakerService Porch for laundryFull bath with tub and stall showerFenced rear yard2 car garage with new driveway'),('P83433','8574 Rancho Road','Newport','CA','92301','active','8000000.0000',10,15,'2',4000,1995,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Almost complete!!. Spanish Mediterranean beauty in Marina Del Rey\'s much sought after Oxford Triangle neighborhood. Available approximately September, 2005. This authentically detailed 2-story property boasts 10 BD+ 15 BA, over 3300 s.f. on over 6100 s.f. lot. Amenities include: hardwood floors, granite kitchen w/ Viking appliances, formal dining w/ wet bar, family room w/fpl and expansive back yard. Convenient Westside location. DRIVE BY ONLY or call agent for appt and more details.'),('P86345','5487 June St.','Orange','CA','92645','active','261000.0000',2,1,'1',780,1983,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,1,'PRICE REDUCED $5000 !! TRULY BEAUTIFUL 2 BEDROOM CO-OP IN COLDWATER NORTH-- WONDERFULL TILE IN THE LIVING ROOM, KITCHEN AND BATHROOM, 2 WALL UNIT A/C\'S, JUST CLEANED CARPET IN BEDROOMS, SECURITY BARS AND RELEASES IN THE BEDROOMS, VERY CLEAN VERY BRIGHT AND VERY AFFORDABLE-- HOA DUES... INCLUDE TAXES ONLY $183 PER MONTH!!!! ALSO COUCHES AND REFRIGERATOR STAY WITH THE UNIT!!!!'),('P873434','27270 Avenida de la Plata','Laguna Niguel','CA','92677','sold','600000.0000',2,3,'2',900,1985,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,0,'Make this desirable TH your home. Enjoy the beautiful hardwood floors, spacious LR, DR, BA & bright, cheerful kitchen. All 3 bedrooms are upstairs. Master w/FP, balcony, high ceilings & 2 walk-in closets. Views to natural setting of rock formation & vegetation. 1 yr old central A/C.'),('P874328','2376 Cooley Drive','Newport','CO','98745','recent','892000.0000',4,2.5,'2',1360,1994,'Single Family Home','2005-10-03 00:00:00',1,1,0,1,'HIS HOUSE IS A MUST SEE. LOVELY WESTPORT HEIGHTS HOME IN A GREAT NEIGHBORHOOD. FANTASTIC MASTER SUITE COMPLETE WITH SEPARATE BATH AND SITTING ROOM AND FRENCH DOORS TO YARD. CUSTOM MASTER BATHROOM HAS EXTRA LARGE SHOWER. 3RD BEDROOM HAS PRIVATE ENTRANCE TO BACKYARD. CHARMING, PRIVATE, BEAUTIFULLY LANDSCAPED BACKYARD HAS ENTERTAINMENT AREA WITH CUSTOM COVERED DECK. REFINISHED WOOD FLOORS, COPPER PLUMBING. CROWN MOLDING, CEILING FANS, A DETACHED 2 CAR GARAGE AND MORE.'),('P874542','P O Box 1167','San Diego','TX','92334','active','650000.0000',3,3,'2',1130,1998,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Totally remodeled end unit 3 bed & 2.5 bath in sought after Beverlywood West Complex. Redone kitchen and dining area w/open, spacious, lite & bright feel, granite countertops, new appliances, tile and hardwood flooring & maple cabinetry. New CFAG, separate laundry room, redone half bath and full bath, extra cabinetry upstairs, private two car garage, peek-a-boo westerly view from master, overlooking park and clubhouse area. Check out virtual tour. Gorgeous unit!'),('P93744','130 N Rancho Ave','San Bernardino','CO','92410','active','900000.0000',3,2,'1',1380,1984,'Single Family Home','2005-10-03 00:00:00',1,1,0,1,'ESCAPE TO PARADISE! THIS EMOTIONAL 2+2 BUNGALOW IS EXCEPTIONAL. OPEN FLR PLAN W/ 2 SEPARATE BEDROOM WINGS. REDONE HWD FLRS, LRG DINING RM W/FRENCH DOORS - GREAT INDOOR / OUTDOOR FLOW. MANY UPGRADES INCL 200AMP ELEC, COPPER PLUMBING, ALARM SYS, CEILING FANS, CABLE / SAT /CAT5 WIRED, DETACHED BONUS RM. DESIGNER TOUCHES THRU-OUT. MAGICAL BACKYARD WITH ARIZONA FLAGSTONE OPEN PATIO, SATILLO TILE COVERED PATIO, FOUNTAINS, MAILBU LIGHTING. DRY RIVER BED LANDSCAPING & SCULPTED GRASS AREA. ONE OF A KIND!'),('Q23434','7747 Alamo Ave.','Paramount','KS','98514','recent','405000.0000',1,1,'2',945,1971,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'FULLY REFURBISHED END UNIT IN SMALL,WELL MAINTAINED COMPLEX BRIGHT GROUND FLOOR UNIT WITH L.R.,D.A.,KITCHEN W/ NEW BUILT-INS REMODELED BA.NEW WASHER & DRYER, PERGO FLOOR IN ALL ROOMS EXCEPT BATH & BDRM. FRESHLY PAINTED, CLOSE TO EVERYTHING. IN MOVE-IN CONDITION. THIS IS A MUST SEE.'),('Q298838','4501 Etiwanda Ave','Mira Loma','CA','91752','active','1000000.0000',3,3,'2',1420,1996,'Single Family Home','2005-10-03 00:00:00',0,0,0,1,'Beautifully recently remodeled. Attention to detail, knotty pine ceiling & wainscoating in Den. Solid pewter FP screen All custom Kitchen cabinets and swing doors, semi pro Jenn Air w/6 burners, 2 ovens, Fischer Paykel Dual Dish Washer, Whirpool W/D, Kitchen Aid Refrigerator/Freezer French imported hardware in bath Crown moldings, wood floors, Dining Room, All custom window treatments, large grassy yard Copper plumbing, all wiring modernized, auto water sprinkler system front & back alarm system'),('Q67676','1103 Bealice St.','San Diego','AZ','92337','active','115000.0000',2,2.5,'1',640,1985,'Multi-Family Home','2005-10-03 00:00:00',0,0,0,0,'PRIME NORTH OF WILSHIRE LOCATION, LARGE 2 BDRM 2 BATH PENTHOUSE (TOP FLOOR). INTERCOM ENTRY, ELEVATOR, AND GATED PARKING. PARKING 2. DINING AREA, BUILT INS , LAUNDRY ROOM ON EACH FLOOR. Natural light, facing south, TORCA CONVERSION, RENT CONTROLED, TENANT OCCUPIED AND GOVERNED BY RENT CONTROL/TORCA LAW. BUYER TO PAY A ONE TIME TORCA TAX. WALK TO MONTANA AND PALISADES PARKWHICH OVERLOOKS THE OCEAN. MUST SEE!! open house tuesday 20th from 11 to2pm.'),('Q76580','24763 New Haven Dr','Denver','CO','92562','active','905000.0000',4,3,'2',1370,1974,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'TRUST SALE. FIXER SOLD AS-IS. LARGE LOT. SEE THIS AND USE YOUR IMAGINATION. CALL YOUR CONTRACTORS. 4BR+3BA + FAMILY RM WITH 2 SEPARATE OUTSIDE ENTRANCES. LIVING RM, DINING AREA AND FAMILY RM W/FIREPLACE. DETACHED 2 CAR GARAGE OFF ALLEY.'),('Q87324','14909 SOUTH BROADWAY','Corona del Mar','CA','','active','3500000.0000',6,2,'2',3200,1997,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'LOCATION, LOCATION, LOCATION! Venice beach Bungalow fixer, 1/2 block to beach on prime walk street, 2 parking spaces in addition to 2 car garage, close to restaurants, canals, and Venice Pier. Build your own 3000 sq ft, 3 story dream home with Ocean view!'),('Q874344','8364 Sultana','San Diego','CA','92335','active','660900.0000',3,3,'1',1175,1982,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'\"Studio Village Townhouses\" with direct access to unit from 2 car garage. Near putting green and landscaped grounds, this unit faces inside and is totally remodeled. Features include: large master bedroom with bathroom, Pergo floors, Smooth Ceiling, Crown Molding, New Windows, plantation shutters, and much more. Unit also has bonus room that can be used as home office. Culver city Schools, great complex, dont miss this one.....'),('R265625','7412 Blue Ave','San Diego','CA','92335','active','250000.0000',2,1,'1',775,1986,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'Beautifully remodeled single story with no common walls - currently used as 1 bedroom plus den. Gourmet kitchen with custom cabinetry, builtins, hardwood floors, plantation shutters, fireplace & inside laundry. Peaceful garden view patio, open floor plan with spacious rooms throughout. Great location within complex, no street noise & walking distance to Village. Building has pool, exercise room, spa & sauna.'),('R343320','11010 Flower Ave.','San Diego','LA','92335','backUp','415000.0000',2,1,'1',980,1987,'Multi-Family Home','2005-10-03 00:00:00',1,1,1,1,'Cute, charming, & decorator sharp one bedroom, one bathroom condo. Awesome courtyard building surrounded by green grass & mature trees. This unit is a rare find with all the charm & character of a single family home. A few of the property\'s features include: formal dining room, newly remodeled kitchen, refinished hardwood floors, private, detached, one-car garage with remote, beautiful views of the courtyard with mature trees & landscaping, & so much more! Convenient location close to all shops, transportation, restaurants, & entertainment. Extremely low HOA dues of $140/mo. Strong HOA with good reserves. Feels larger than square footage. There is nothing this charming & unique on the market! Don\'t miss out. Easy to show, just call the listing agent direct. This unit has a front & back door (just like a house) and the laundry facilities are just steps away from your back door. Parking garage assigned to this unit is #16. Subject to seller finding their HOC & closing concurrently.'),('R454448','8578 Arrow Ave.','San Diego','CA','92335','recent','675000.0000',3,2,'1',1186,1999,'Single Family Home','2005-10-03 00:00:00',1,1,1,1,'GREAT FAMILY MAR VISTA HOME IN PRIME CORNER LOCATION. SUNNY LIVING ROOM W/ FIREPLACE, BAY WINDOW, HARDWOOD FLOORS, AND CROWN MOLDINGS. COMPLETELY REMODELED KITCHEN LEADS TO FORMAL DINING ROOM. REMODELED BATHROOM MASTER BATH W/ GLASS SHOWER ENCLOSURE. HUGE PRIVATE BACKYARD W/ BUILT IN BBQ AND TWO PATIOS! LOVELY LANDSCAPING IN FRONT AND BACKYARD. 2-CAR GARAGE. SELLER SELECTS ALL SERVICES. OPEN HOUSE SATURDAY & SUNDAY!'),('R56582','33320 Mission Trail','Wildomar','CA','','active','923000.0000',3,3,'1',1310,1995,'Condo/Townhouse','2005-10-03 00:00:00',0,0,0,0,'Beautifully remodeled townhome, 1932 S.F. 3 Bedroom/ 2.5 bath , Den/ Family room. This is a showcase, very sophisticated and unique. New kitchen w/ granite counters, hardwood flrs. throughtout, custom fireplace and railing, plantation shutters, new windows, A/C. Steps from lovely pool area. 3 Car garage, many extras. Seller is Real Estate agent.'),('R76323','11045 Maple Ave','Denver','CO','92316','active','5600000.0000',5,2.5,'3',1200,1987,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'The splendor of the Santa Monica Mountains awaits you outside your living room windows and patio. Mountain views from this Pacific Palisades townhome with 3 Bedrooms and 2.5 baths. New paint, wood floors and windows. Needs some updating. Exceptional climate mid Palisades Highlands. 2 car attached garage w/ direct entry. Vacant and ready to go. Community pool, spa, and fitness. Priced to sell for short escrow. Call agent for lockbox code. NO SHOWINGS UNTIL TUES AUG. 9TH.'),('S213434','11701 Whittram Street','Irvine','LA','91730','recent','420900.0000',2,2,'1',970,1972,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,1,'2BR/2BA CONDO, GATED COMMUNITY WITH POOL, SPA AND RECREATION ROOM. BELOW MARKET PRICE. SELLING AS IS.'),('S565683','1313 E PHILLIPS BLVD','POMONA','AK','87512','active','935000.0000',4,2,'2',1330,1975,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'1ST SHOWING TUES OCT 4TH 11-2 & SUN OCT 9TH 2-5PM. FABULOUS RESTORED 1920\'S MINI COMPOUND PUBLISHED IN MAGAZINES. THE PROPERTY FEATURES A LARGE LOT ON A GREAT SRTEET W/ EXPANSIVE FRONT & REAR YARDS. THE COTTAGE HAS INCREDIBLE ORIGINAL DETAILS & CHARM. THE HOME IS LIGHT & OPEN WITH A GREAT ROOM W/ FIREPLACE & FORMAL DINING, SUPER WIDE PLANK FLOORS, HIGH CEILINGS & A GOURMET KITCHEN. A MUST SEE'),('S674455','4174 South River','Riverside','CA','92509','sold','680000.0000',3,3,'2',1190,1983,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Spacious 3 BR, 2.75 BA home in Culver City with pool & hot tub. 5th BR can be used as family room. Eat-in kitchen w/ tile floors and water filtration system. Living/dining room has a wood-burning/gas fireplace. Partial copper plumbing and vinyl windows. Other amenities include; Laundry room, RV parking spot and intercom system. Needs TLC.'),('S869265','9017 Arrow','Newport','CA','91730','recent','3620000.0000',3,3,'2',3300,2001,'Single Family Home','2005-10-03 00:00:00',1,1,1,0,'Exquisite Architectural 2-sty home w/over 2,700 s.f. of spacious living and modern design. 3bds/3bths+loft - amazing kitchen, updated appliances, Mstr Suite w/walk in closet, Large inviting LR w/wood flrs, hi ceilings, 3 FPs, Rooftop w/panoramic view to die for & plenty of parking. Fab area in Venice w/good schools & steps away from Abbot Kinney & Beach. MUST SEE INSIDE TO APPRECIATE. NO PUBLIC OPEN HOUSES - Call to schedule appt during week or weekend. NO SIGN ON PROPERTY.'),('T454522','2353 South Cactus','Dana Point','MD','92316','active','430900.0000',2,2,'2',985,1988,'Condo/Townhouse','2005-10-03 00:00:00',1,1,1,1,'Nice 2+1.5 condominium w/good floor plan & large patio. Great complexw/park-like grounds, grassy play area, pool, tennis courts. Master bedroom w/walk-in closet and bathroom. Excellent shape w/some upgrades, new tile in bath & kitchen, new stove, dishwasher, new tub/shower stall. 1st floor unit w/large outdoor patio. Feels larger than 779 sq.ft.'),('T574353','15135 boyle ave','San Diego','CA','92337','recent','695000.0000',2,2,'1',1200,2000,'Condo/Townhouse','2005-10-03 00:00:00',0,1,0,0,'2ND FLOOR UNIT WITH NEW STOVE, COUNTERTOPS AND TILE FLOORS IN KITCHEN. NEW WINDOWS THROUGHOUT UNIT. APPLIANCES INCLUDED WITH UNIT. FIREPLACE IN LIVING ROOM. CARPET IN LIVING ROOM AND BEDROOMS. COMPLEX HAS 3 POOLS, TENNIS COURT, SPA, CLUBHOUSE, GYM, MONTESSORI SCHOOL AND MORE. HOA FEES COVER GAS, WATER AND CABLE TV. CLOSE TO NEARBY SHOPPING AND FREEWAYS. SELLER CHOOSES SERVICES.'),('T654584','8741 S Linden Ave.','Dana Point','AL','92337','active','945000.0000',4,3,'2',1320,1996,'Single Family Home','2005-10-03 00:00:00',0,0,0,0,'OPEN SUN 9/18 1 TO 4 PM * AGENTS COMBO BOX - TO SHOW CALL L/OFC**PRICE REDUCED 9/14* Fabulous location in Sunset Park on one of the highest spots in Santa Monica. Add a 2nd story for ocean to mountain views. Gourmet kitchen w/granite counters, maple cabinetry, stainless appliances & Pella designer series windows. Refinshed hardwood floors. Formal dining rm. 200 amp upgraded electrical. Copper plumbing. Radiant heating under the flooring. Included is a near-new deluxe Sundance spa. More'),('U343423','8432 Almeria St.','Canoga Lake','MD','92335','sold','440000.0000',2,2,'2',1000,1973,'Multi-Family Home','2005-10-03 00:00:00',1,0,1,1,'Canogalakes.com Fantastic Canoga Lakes resort-like gated security complex with lakes, waterfalls and expansive greenbelts. Upper unit with vaulted ceilings and big converted loft. Balcony overlooks tranquil streams. Relax in the community pools, spas, and saunas. Recreation facilities include lighted tennis courts and gym'),('U347459','28177 Keller Road','Menifee','GA','92584','active','705000.0000',2,2,'2',1205,1984,'Condo/Townhouse','2005-10-03 00:00:00',1,0,1,0,'CHARMING BEACH AREA 2 BR, 2.5 BATH TOWNHOUSE. WALK TO BEACH, RESTAURANTS & BOATS, LIVING RM, FAMILY & DINING AREA HAVE SMOOTH CEILINGS WITH RECESSED LIGHTING, HARDWOOD FLRS. HIGH CEILING IN LIVING RM W/SHUTTERS WHICH STEPS OUT TO PRIVATE PATIO. TWO MASTER BR SUITES ON SEPERATE LEVELS. DIRECT ACCESS TO PRIVATE 2 CAR GARAGE. POOL, SPA, SAUNA, EXERCISE RM. OPEN SUN 8/21/05-2:00-5:00. OFFERS PRESENTED AFTER BROKERS OPEN 8/23/05-12:00-2:00.'),('U455486','555 East Ocean Blvd. Suite # 510','Long Beach','AL','90802','active','962000.0000',3,2,'2',1390,1976,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'Immaculate, custom Tuscan-style home built in 2002 on cul-de-sac. Hardwood floors thru-out, marble floors in kitchen and bathrooms, berber carpet in bedrooms. Gourmet kitchen w/ stainless steel, walk-in pantry, center island. Granite countertops thru-out. Custom paint and window coverings. Beautifully landscaped, spacious backyard w/dog run. Whole house audio. Cat-5 wiring. Large master suite w/balcony and huge walk-in closet, dual-head shower and jacuzzi tub. Open 9/10 & 9/11 11:00-4:00'),('V66453','121 S. Indian Hill Blvd.','Pomona','DE','56852','active','715000.0000',3,2,'1',1250,2001,'Single Family Home','2005-10-03 00:00:00',1,0,1,0,'Atrractive, refurbished family home in great Sunkist Park Neigborhood of Culver City. Remodeled kitchen w/ granite countertops and new cabinetry. Upgraded family room wtih marble fireplace and doors leading to enclosed patio and beautifully lanscaped yard w/ fruit trees and above ground pool. 2 car garage with new garage door. Located close to all major shopping, Parks, transportation and award winning El Marino Language School. Call listing agent for details.'),('V894533','1212 South Mountain View','San Bernardino','AL','92408','active','956000.0000',3,2,'1',1360,1997,'Single Family Home','2005-10-03 00:00:00',1,0,0,0,'Stunning Charmer on Desirable Sunset Park cul-de-sac. Bright 3Bedroom/2Bath including master suite w/remodeled bath, hardwood floors, and sliding Shoji Doors. Skylight filled entry hall leads to Light & Spacious Kitchen-Dining-Living Area w/new Berber Carpet & Fireplace. French doors open to redwood deck & professionally landscaped garden w/mature trees + Bonus Converted Garage/Guest/Office w/secure storage space. Walk to park/Minutes from beach. Seeing is believing! Offers Rev.Th. 9/22'),('W435324','1405 E LOCUST','Redondo Beach','CO','','backUp','450000.0000',2,2,'1',1010,1989,'Multi-Family Home','2005-10-03 00:00:00',1,0,0,1,'Newly reconstructed, Modern Craftsman in One of the areas best locations. Main level LR with cathedral ceilings & Fireplace leading to Spectacular Cooks kitchen with state-of the art appliances granite counters, Dining area, breakfast bar & unique outdoor dining entertaining area. Direct entry from the two car garage. Second level bed & bath with Juliet balcony overlooking the LR. Plush master with dual master Bath & Hugh walk in closet. 3rd Level gst suite with balcony & View'),('W45459','2745 N Locust Ave','San Diego','AL','','active','963000.0000',4,3,'1',1370,1977,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'Newly renovated 2005! Contemporary Traditional with a touch of Glamour. High ceilings dark wood floors & custom finishes throughout. Amazing cooks kitchen w/black granite counters & island. S/S appliances. L/R w/large F/P. Seperate D/R. Master bedroom has custom cabinetry & entertainment unit. Custom black granite master bath. D/R, kitchen and master bedroom open to wood decks. Seller is developer and is motivated.'),('W605645','PO Box 504','Daggett','AZ','92327','active','723900.0000',3,3,'1',1210,1985,'Single Family Home','2005-10-03 00:00:00',1,0,1,0,'Cheerful home with plenty of elbow room. Large master BR, BA, new in 1998. Family room opens to backyard with mature avocado tree. Quiet tree-lined street. Good size LR & great flow for entertaining. All new electrical. Wood-burning fireplace in both LR & FR. Double garage in rear with 3 car uncovered tandem parking. Open Saturday 9/3 2-5 PM.'),('X344425','20123','Northridge','MD','90321','recent','460500.0000',2,1,'2',1025,1990,'Multi-Family Home','2005-10-03 00:00:00',1,0,1,1,'Spacious top floor unit with large balcony. Storage room on balcony. Large master bedroom with walk in closet. Lots of storage. Open kitchenwith pantry. The building features a pool, two elevators, community laundry room and large patio area. The building is close to freeways'),('X454592','5846 Jasmine','Riverside','AL','','recent','978000.0000',3,1,'2',1400,1998,'Single Family Home','2005-10-03 00:00:00',0,1,0,0,'Excellent 3BR 1BA home on a quiet street in Venice with professionally remodeled bonus room in back. Home has been freshly painted inside and out with an open floor plan and loads of storage space. Home is situated 1.8 miles from the beach and has great neighbors and parking is always available. Bonus room in back is detached from the front house and is newly remodeled with a 1/2 bath, skylights, quality paint and tile. Studio is 390 Sq.Ft. with an additional 130 Sq.Ft of enclosed storage sp'),('X454615','6325 Plaza Ave','Long Beach','AZ','91452','recent','736000.0000',3,2,'1',1220,2002,'Single Family Home','2005-10-03 00:00:00',1,0,1,0,'Charming 3 bedroom 2 bath home on a lot and a half. Permitted additions of extra bedroom and family room. 2 huge walk in closet an covered patio. Remodeled kitchen in the 90\'s/ New 30y Roof/ All New Copper plumbing and upgraded electrical. 405 Fwy entrance and exit conveniently close. Double ply windows/ Ceiling fans throughout/ Beautiful Hardwood floors/tile and carpet. Iron Sliding gate from alley for RV access. Buyer to cooperate with buyers 1031 Exchange.'),('Y564362','9222 Las Lomas Lindas','Maplewoods','AZ','91761','backUp','740900.0000',2,3,'1',1230,1986,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'This beautifully remodeled townhome is very light, bright & is in the perfect serene poolside location. Feat. all the modern \"Bells & Whistles\" your client has been looking for! Has granite counter tops, & newer appli in kit, smth ceil w/recessed lights & plantation shutters thru-out, lrg skylt, gorgeous granite & tile baths, all nw lights & hardware, lrg priv encl brick patio off lv rm w/fp. This stunning unit will go quickly!***EASY TO SHOW***NO SHOWINGS ON THURSDAYS***'),('Y763326','2523 North Oak','Avalon','MD','93251','active','475000.0000',2,2,'1',1035,1974,'Multi-Family Home','2005-10-03 00:00:00',1,0,1,1,'Contractors? or first time buyer?...Here it is an affordable home built in 1922 and offering 1 bedroom and 1 bath on a corner lot. This starter home offers an open living and kitchen area and lots of natural light. The generous bedroom has views of the rear yard. The yard is perfect for outdoor barbecues or a private garden. This cosmetic fixer is located North of York Blvd. and offers easy access to shopping, Eagle Rock and Occidental College. A rare opportunity!'),('Z676463','8874 Forte St','Aliso','AZ','95641','backUp','750900.0000',3,2,'2',1280,2003,'Condo/Townhouse','2005-10-03 00:00:00',1,1,0,1,'Charming, well maintained home in Sunkist Park of Culver City. 2 bedrooms 1.5 bathrooms, family room, dining room, and eat in kitchen, updated kitchen w/ granite tile countertops & maple cabinetry, hardwood floors, and crown molding. 2 car garage with direct entry. Large backyard. Close to all major shopping and transportation and award winning El Marino Language School and one minute walk to El Marino Park. Don\'t miss seeing this wonderful home.'),('Z873327','8512 Hawthorne','Redondo','MN','95214','recent','480900.0000',2,2,'1',1040,1991,'Multi-Family Home','2005-10-03 00:00:00',1,1,0,0,'NEW CARPET, PAINT AND DISHWASHER. HOA INCLUDES CABLE TV, GAS AND WATER.GREAT COMPLEX WITH 3 SWIMMING POOLS AND MONTESSORI SCHOOL ON PREMISE.BUYER TO TO COOPERATE WITH SELLERS TAX FREE EXCHANGE AT NO COST TO BUYER. OWNER HAS CALIFORNIA REAL ESTATE LICENSE. NO SHOWINGS BEFORE BROKER\'S OPEN HOUSE ON 9/20. PUBLIC OPEN HOUSE 1-5 ON 9/25. ALL OFFERS TO BE REVIEWED ON 9/26.');
UNLOCK TABLES;

--
-- Table structure for table `state`
--

DROP TABLE IF EXISTS state;
CREATE TABLE state (
  state_id char(2) NOT NULL default '',
  name varchar(100) default NULL,
  PRIMARY KEY  (state_id)
) TYPE=MyISAM;

--
-- Dumping data for table `state`
--

LOCK TABLES state WRITE;
INSERT INTO state VALUES ('AK','Alaska'),('AL','Alabama'),('AR','Arkansas'),('AS','American Samoa'),('AZ','Arizona'),('CA','California'),('CO','Colorado'),('CT','Connecticut'),('DC','District Of Columbia'),('DE','Delaware'),('FL','Florida'),('GA','Georgia'),('GU','Guam'),('HI','Hawaii'),('IA','Iowa'),('ID','Idaho'),('IL','Illinois'),('IN','Indiana'),('KS','Kansas'),('KY','Kentucky'),('LA','Louisiana'),('MA','Massachusetts'),('MD','Maryland'),('ME','Maine'),('MH','Marshall Islands'),('MI','Michigan'),('MN','Minnesota'),('MO','Missouri'),('MP','Northern Mariana Islands'),('MS','Mississippi'),('MT','Montana'),('N/','Select if Country is USA'),('NC','North Carolina'),('ND','North Dakota'),('NE','Nebraska'),('NH','New Hampshire'),('NJ','New Jersey'),('NM','New Mexico'),('NV','Nevada'),('NY','New York'),('OH','Ohio'),('OK','Oklahoma'),('OR','Oregon'),('PA','Pennsylvania'),('PR','Puerto Rico'),('PW','Palau'),('RI','Rhode Island'),('SC','South Carolina'),('SD','South Dakota'),('TN','Tennessee'),('TX','Texas'),('UT','Utah'),('VA','Virginia'),('VI','Virgin Islands'),('VT','Vermont'),('WA','Washington'),('WI','Wisconsin'),('WV','West Virginia'),('WY','Wyoming');
UNLOCK TABLES;
